#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1000003
using namespace std;

int n, m;
int maxt = 0;
pair <int, int> tree[MAXN << 2];
vector <pair<int, int>> v;

pair<int, int> maxx(pair<int, int> p, pair<int, int> q)
{
    return p.first >= q.first ? p : q;
}

void recalc(int v)
{
    tree[v] = maxx(tree[v << 1], tree[(v << 1) + 1]);
}

void update(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return;

    if (l == r)
    {
        //cout << v << ": " << l << " " << r << " - " << tree[v] << endl;
        tree[v].first++;
        tree[v].second = l;
        return;
    }

    int mid = (l + r) >> 1;
    update(v << 1, l, mid, x, y);
    update((v << 1) + 1, mid + 1, r, x, y);
    recalc(v);
}

pair<int, int> get(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return {-1, -1};

    if (l >= x && r <= y)
        return tree[v];

    int mid = (l + r) >> 1;
    auto left1 = get(v << 1, l, mid, x, y);
    auto right1 = get((v << 1), mid + 1, r, x, y);
    return maxx(left1, right1);
}

void input()
{
    cin >> n >> m;

    for (int i = 0; i < n; ++i)
    {
        int a, b;
        cin >> a >> b;
        v.push_back({a, b});
        maxt = max(maxt, b);
        //update(1, 1, maxt, a, b);
    }

    maxt += m;

    for (auto tmp: v)
    {
        //cout << "update: " << tmp.first << " " << tmp.second << endl;
        update(1, 1, maxt, tmp.first, tmp.second);
    }

    /*for (int i = 1; i < maxt << 2; ++i)
        cout << i << ": " << tree[i] << endl;
    cout << endl;*/
}

int arr[MAXN];
int cnt[MAXN];
int best = 0;

void solve()
{
    /*for (int i = 1; i < maxt - m; ++i)
    {
        arr[i] = get(1, 1, maxt, i, i + m - 1);
        cout << arr[i] << " ";
    }

    cout << endl;

    cnt[maxt-m-1] = arr[maxt-m-1];
    for (int i = maxt - m - 2; i >= 0; --i)
    {
        cnt[i] = max(arr[i], cnt[i+1]);
    }



    for (int i = 1; i < maxt - m; ++i)
    {
        best = max(best, arr[i] + cnt[i+m]);
    }*/

    auto tmp1 = get(1, 1, maxt, 1, maxt);
    auto tmp2 = maxx(get(1, 1, maxt, 1, tmp1.second - 1), get(1, 1, maxt, tmp1.second + 1, maxt));

    cout << tmp1.first + tmp2.first << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
