#include<iostream>
using namespace std;
const int MOD=1000000007;

struct P
{
    int c;
    bool nailed;
    int id;
};
P pos[500001];

long long  fastpow(int power, int core)
{
    if(power==0) return 1;
    if(power==1) return core%MOD;
    if(power==2) return (core*core)%MOD;
    return (fastpow(power/2, core)*fastpow(power-(power/2),core))%MOD;
}

int n,k;

void Read()
{
    cin>>n>>k;
    for(int i=0;i<n;i++)
    {
        cin>>pos[i].c;
        if(pos[i].c!=0) pos[i].nailed=true;
    }
}

long long Solve()
{
    if(n==1)
    {
        if(pos[0].nailed==0) return k;
        else return 1;
    }
    if(pos[1].nailed==1)
    {
        pos[0].id--;
    }
    else
    {
        pos[1].id--;
    }
    pos[2].id--;
    for(int i=2;i<n;i++)
    {
        if(pos[i].nailed==1)
        {
            if(pos[i].c!=pos[i-2].c)
            {
                pos[i-1].id--;
            }
        }
        pos[i+1].id--;
    }
    int p0=0,p1=0,p2=0;
    for(int i=0;i<n;i++)
    {
        if(pos[i].nailed==0)
        {
            if(pos[i].id==-1) p1++;
            else if(pos[i].id==-2) p2++;
            else if(pos[i].id==0) p0++;
            else return 68+1;
        }
    }
    long long ans=0;
    ans=(fastpow(p1,k-1)*fastpow(p2,k-2))%MOD;
    ans=(ans*fastpow(p0,k))%MOD;
    return ans;
}

int main()
{
    Read();
   /* for(int i=0;i<n;i++)
    {
        cout<<pos[i].nailed<<" "<<pos[i].c<<" "<<pos[i].id<<endl;
    }*/
    cout<<Solve()%MOD<<endl;
    /*for(int i=0;i<n;i++)
    {
        cout<<pos[i].nailed<<" "<<pos[i].c<<" "<<pos[i].id<<endl;
    }*/
    return 0;
}
