#include <bits/stdc++.h>
using namespace std;

int n, m;
const int MAXNM = 1500;
char c[MAXNM][MAXNM];
int q;
const int MAXQ = 1e5;

/*int curr_path = 1;
int path[MAXNM][MAXNM];
int path_length[MAXNM * MAXNM];*/

int dist[MAXNM][MAXNM];
bool used[MAXNM][MAXNM];
//unordered_set<pair<int, int>> within;

int dfs(int x, int y) {
    used[x][y] = true;
    int x1 = 0, y1 = 0;
    switch(c[x][y]) {
        case '>':
            x1 = 1;
            break;
        case 'v':
            y1 = 1;
            break;
        case '<':
            x1 = -1;
            break;
        case '^':
            y1 = -1;
            break;
    }
    //cout << x << " " << y << " " << x1 << " " << y1 << endl;
    if(x + x1 < 0 || x + x1 >= m || y + y1 < 0 || y + y1 >= n)
        return dist[x][y] = 1;
    if(used[x + x1][y + y1] == true)
        return dist[x][y] = numeric_limits<int>::min();
    //cout << "Survived" << endl;
    if(dist[x + x1][y + y1] != 0)
        return dist[x][y] = dist[x + x1][y + y1] + 1;
    return dfs(x + x1, y + y1) + 1;
}

int main() {
    cin >> n >> m;
    for(int y = 0; y < n; ++y) {
        string s;
        cin >> s;
        for(int x = 0; x < m; ++x)
            c[x][y] = s[x];
    }
    /*for(int y = 0; y < n; ++y) {
        for(int x = 0; x < m; ++x) {
            cout << c[x][y];
        }
        cout << endl;
    }*/

    /*for(int y = 0; y < n; ++y) {
        for(int x = 0; x < m; ++x) {
            if(dist[x][y] == 0) {
                memset(used, 0, sizeof(used));
                dist[x][y] = dfs(x, y);
            }
        }
    }*/
    /*for(int y = 0; y < n; ++y) {
        for(int x = 0; x < m; ++x) {
            cout << dist[x][y] << " ";
        }
        cout << endl;
    }*/
    cin >> q;
    for(int i = 0; i < q; ++i) {
        int x, y, x1, y1;
        char newc;
        cin >> y >> x >> y1 >> x1 >> newc;
        --x;
        --y;
        --x1;
        --y1;
        char oldc = c[x1][y1];
        c[x1][y1] = newc;
        memset(dist, 0, sizeof(dist));
        memset(used, 0, sizeof(used));
        int ans = dfs(x, y);
        if(ans < 0)
            ans = 0;
        cout << ans << endl;
        c[x1][y1] = oldc;
    }

    return 0;
}
