#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <queue>

using namespace std;

int n,m;
int Path=1;
int gr[1515];
bool used[2];
bool inCycle[2];
int PathNo[2];
int Exit[2];
set <int> path;



bool FindExit(int node)
{
	if(path.find(node)!=path.end())
	{
		inCycle[node]=true;
		PathNo[node]=Path;
		Path++;
		return false;
	}
	if(used[node])return Exit[node];
	if(gr[node]==-1)
	{
		used[node]=true;
		Exit[node]=1;
		PathNo[node]=Path;
		Path++;
		return true;
	}
	if(Exit[gr[node]]!=0)
	{
		Exit[node]=Exit[gr[node]]+1;
		Path++;
		PathNo[node]=Path;
		return true;
	}
	used[node]=true;
	path.insert(node);
	if(FindExit(gr[node]))
	{
		Exit[node]=Exit[gr[node]]+1;
		PathNo[node]=PathNo[gr[node]];
		return true;
	}
	else {
		inCycle[node]=true;
		PathNo[node]=PathNo[gr[node]];
		return false;
	}
	
}

void Print()
{
	for(int i=0;i<n;i++)
	{
		cout<<i<<"-";
		for(int j=0;j<m;j++)
			cout<<PathNo[i*m+j]<<" ";
		cout<<endl;
	}
}

void init()
{
	char x;
	scanf("%d%d",&n,&m);
	for(int i=0;i<n;i++)
		for(int j=0;j<m;j++)
		{
			cin>>x;
			switch(x)
			{
				case '>':if(j<m-1)gr[i*m+j]=i*m+j+1;else gr[i*m+j]=-1;break;
				case '<':if(j>0)gr[i*m+j]=i*m+j-1;else gr[i*m+j]=-1;break;
				case '^':if(i>0)gr[i*m+j]=(i-1)*m+j;else gr[i*m+j]=-1;break;
				case 'v':if(i<n-1)gr[i*m+j]=(i+1)*m+j;else gr[i*m+j]=-1;break;
			};			
		}
}

void solve()
{	
	for(int i=0;i<n*m;i++)
	{
		path.clear();
		FindExit(i);
//	Print();
	}	
	int Q,sx,sy,posx,posy,newpos,startpos,nextpos;
	char diff;
	
	cin>>Q;
	while(Q--)
	{
		scanf("%d%d%d%d",&sx,&sy,&posx,&posy);
		cin>>diff;
		sx--;
		sy--;
		posx--;
		posy--;
		newpos=posx*m+posy;
		startpos=sx*m+sy;

		if(PathNo[newpos]==PathNo[startpos])
		{
			if(Exit[newpos]>Exit[startpos])cout<<Exit[startpos]<<endl;
			else {
				switch(diff)
				{
					case '>':if(posy<m-1)nextpos=posx*m+posy+1;else nextpos=-1;break;
					case '<':if(posy>0)nextpos=posx*m+posy-1;else nextpos=-1;break;
					case '^':if(posx>0)nextpos=(posx-1)*m+posy;else nextpos=-1;break;
					case 'v':if(posx<n-1)nextpos=(posx+1)*m+posy;else nextpos=-1;break;
				};
				if(inCycle[nextpos])cout<<0<<endl;
				else if(nextpos=-1)cout<<Exit[startpos]-Exit[newpos]+1<<endl;
				else cout<<Exit[startpos]-Exit[newpos]+1+Exit[nextpos]<<endl;
			}
		}
		else {
			if(inCycle[startpos])cout<<0<<endl;
			else cout<<Exit[startpos]<<endl;
		}
		
		
	}
}

int main()
{
	init();
	solve();
}
