#include <iostream>
using namespace std;

const int MAXN = 500005;
const int MOD = 1000000007;

long long n, k;
int c[MAXN];


int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> c[i];
    }

    long long comm, diff, idx;
    if (c[1] == 0) {comm = 1; diff = idx = 0;}
    if (c[1] != 0) {comm = 0; diff = 1; idx = c[1];}


    // cout << diff << ' ' << comm << ' ' << idx << endl;

    for (int i = 2; i <= n; ++ i)
    {
        long long ndiff = 0, ncomm = 0;

        if (c[i] != 0)
        {
            if (c[i] == idx)
            {
                ncomm = 0;
                ndiff = (k - 1) * comm % MOD;
            }
            else
            {
                ncomm = 0;
                if (idx != 0) ndiff = ((k - 2) * comm + diff) % MOD;
                else ndiff = (k - 1) * comm % MOD;
                idx = c[i];
            }
        }
        else
        {
            ndiff = (k - 1) * comm % MOD;
            if (idx != 0) ncomm = ((k - 2) * comm + diff) % MOD;
            else ncomm = ((k - 1) * comm) % MOD;
        }

        diff = ndiff;
        comm = ncomm;

        // cout << diff << ' ' << comm << endl;
    }

    long long ans = 0;
    if (idx != 0) ans = (diff + (k - 1) * comm) % MOD;
    else ans = k * comm % MOD;

    cout << ans << endl;
    return 0;
}
