#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42,mod=1e9+7;

int n,k,inp[nmax];

long long outp=1;

long long pwr(long long a,int b)
{
    long long ret=1;

    while(b)
    {
        if(b%2)ret=ret*a%mod;
        b=b/2;
        a=a*a%mod;
    }
    return ret;
}

long long one_way(int sz)
{
    //cout<<"one_way "<<sz<<endl;

    return pwr(k-1,sz)%mod;
}

long long dp[nmax][2];

long long solve(int sz,bool eq)
{
    if(sz==0)return !eq;

    if(dp[sz][eq]!=-1)return dp[sz][eq];

    long long ret=0;

    if(eq==1)
    {
        ret=solve(sz-1,0)*(k-1)%mod;
    }
    else
    {
        ret=solve(sz-1,0)*(k-2)%mod;
        ret=(ret+solve(sz-1,1))%mod;
    }

    dp[sz][eq]=ret;
    return ret;
}

int main()
{
    memset(dp,-1,sizeof(dp));

    scanf("%i%i",&n,&k);

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    vector<int> non_zero={};

    for(int i=1;i<=n;i++)
        if(inp[i])non_zero.push_back(i);

    if(non_zero.size()==0)
    {
        printf("%lld\n",1LL*k*pwr(k-1,n-1)%mod);
        return 0;
    }

    outp=outp*one_way(non_zero[0]-1)%mod;

    //cout<<"outp= "<<outp<<endl;

    outp=outp*one_way(n-non_zero.back())%mod;

    //cout<<"outp= "<<outp<<endl;

    for(int i=0;i+1<non_zero.size();i++)
        outp=outp*solve(non_zero[i+1]-non_zero[i]-1,inp[non_zero[i+1]]==inp[non_zero[i]])%mod;

    printf("%lld\n",outp);

    return 0;
}