#include<bits/stdc++.h>
using namespace std;

const int nmax=1.5e3+42,qmax=1e5+42;

int n,m;

char inp[nmax][nmax];

void read_char(char &c)
{
    c=getchar();

    while(c!='<'&&c!='>'&&c!='^'&&c!='v')c=getchar();
}

int been[nmax][nmax];

int q_now;

struct query
{
    int x_start,y_start,x_change,y_change;
    char cur;
};
query queries[qmax];

struct to
{
    int x,y,moves;
};
to nxt[nmax][nmax];

int steps=0;

bool stop[nmax][nmax];

void go_back(int x,int y,int x_start,int y_start,int moves)
{
    if(moves)
    {
        if(x<=0||x>=n+1||y<=0||y>=m+1)return;

        if(stop[x][y])return;
    }

    nxt[x][y].x=x_start;
    nxt[x][y].y=y_start;
    nxt[x][y].moves=moves;

    if(inp[x-1][y]=='v')go_back(x-1,y,x_start,y_start,moves+1);

    if(inp[x+1][y]=='^')go_back(x+1,y,x_start,y_start,moves+1);

    if(inp[x][y-1]=='>')go_back(x,y-1,x_start,y_start,moves+1);

    if(inp[x][y+1]=='<')go_back(x,y+1,x_start,y_start,moves+1);
}

int solve_query(query now)
{
    q_now++;

    int x=now.x_start,y=now.y_start;
    int x_change=now.x_change;
    int y_change=now.y_change;
    char c=now.cur;

    //scanf("%i%i%i%i",&x,&y,&x_change,&y_change);
    //read_char(c);

    char was=inp[x_change][y_change];

    inp[x_change][y_change]=c;

    int outp=0;

    while(been[x][y]!=q_now)
    {
        //cout<<"go "<<x<<" "<<y<<endl;

        if(x<=0||x>=n+1||y<=0||y>=m+1)
        {
            inp[x_change][y_change]=was;

            return outp;
        }

        been[x][y]=q_now;

        if(nxt[x][y].x==0&&nxt[x][y].y==0)
        {
            inp[x_change][y_change]=was;

            return 0;
        }

        if(nxt[x][y].moves!=0)
        {
            outp+=nxt[x][y].moves;

            int x_new=nxt[x][y].x;
            int y_new=nxt[x][y].y;

            x=x_new;
            y=y_new;
            continue;
        }

        if(inp[x][y]=='<')y--;
        else if(inp[x][y]=='>')y++;
        else if(inp[x][y]=='^')x--;
        else x++;

        outp++;
    }

    inp[x_change][y_change]=was;

    return 0;
}

int slow(query now)
{
    q_now++;

    int x=now.x_start,y=now.y_start;
    int x_change=now.x_change;
    int y_change=now.y_change;
    char c=now.cur;

    //scanf("%i%i%i%i",&x,&y,&x_change,&y_change);
    //read_char(c);

    char was=inp[x_change][y_change];

    inp[x_change][y_change]=c;
    q_now++;

    int outp=0;

    while(been[x][y]!=q_now)
    {
        been[x][y]=q_now;

        if(inp[x][y]=='<')y--;
        else if(inp[x][y]=='>')y++;
        else if(inp[x][y]=='^')x--;
        else x++;

        outp++;

        if(x==0||x==n+1||y==0||y==m+1)
        {
            inp[x_change][y_change]=was;

            return outp;
        }
    }

    inp[x_change][y_change]=was;

    return 0;
}



void solve(int l,int r)
{
    memset(nxt,0,sizeof(nxt));
    memset(stop,0,sizeof(stop));

    set< pair<int,int> > in={};

    for(int i=l;i<=r;i++)
    {
        stop[queries[i].x_change][queries[i].y_change]=1;

        in.insert({queries[i].x_change,queries[i].y_change});
    }

    for(auto w:in)
        go_back(w.first,w.second,w.first,w.second,0);

    for(int i=0;i<=n+1;i++)
        for(int j=0;j<=m+1;j++)
        {
            if(1<=i&&i<=n&&j!=0)j=m+1;

            if(i==0||i==n+1||j==0||j==m+1)
                go_back(i,j,i,j,0);
        }
    /*
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            cout<<i<<" "<<j<<" -> "<<nxt[i][j].x<<" "<<nxt[i][j].y<<" "<<nxt[i][j].moves<<endl;
    */
    for(int i=l;i<=r;i++)
    {
        printf("%i\n",solve_query(queries[i]));

        //assert(solve_query(queries[i])==slow(queries[i]));
    }

}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            read_char(inp[i][j]);

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        scanf("%i%i%i%i",&queries[i].x_start,&queries[i].y_start,&queries[i].x_change,&queries[i].y_change);

        read_char(queries[i].cur);

        stop[queries[i].x_change][queries[i].y_change]=1;
    }

    int BLOCK=max(1,q/20+1);

    for(int i=1;(i-1)*BLOCK+1<=q;i++)
    {
        int l=(i-1)*BLOCK+1;
        int r=min(i*BLOCK,q);

        solve(l,r);
    }

    return 0;
}
/*
5 5
^v<^^
v<<^>
^^^^v
<vvv^
><>vv
10
4 2 5 3 v
3 1 1 5 >
5 5 2 3 ^
2 3 3 5 v
4 4 5 4 >
1 5 1 5 ^
5 1 5 4 <
2 1 1 1 ^
2 4 1 2 >
3 5 5 4 <
*/