#include<iostream>
#include<string>
#include<algorithm>
#include<cmath>
#include<vector>
#include<stack>
#include<queue>
using namespace std;

const int MAXN = 1504;

int n, m;
int q;
char way[MAXN][MAXN];
char old;
bool vis[MAXN][MAXN];

void To_Zero ()
{
    for (int i=1; i<=n; i++)
        for (int j=1; j<=m; j++)
            vis[i][j]=false;
}

void Init ()
{
    cin>>n>>m;
    for (int i=1; i<=n; i++)
    {
        string s;
        cin>>s;
        for (int j=1; j<=m; j++)
            way[i][j]=s[j-1];
    }
}

int Find_Way (int sx, int sy)
{
    To_Zero ();
    int x=sx, y=sy;
    int cnt=0;
    while (true)
    {
        if (vis[x][y])
        {
            cnt=0;
            break;
        }
        cnt++;
        vis[x][y]=true;
        if (way[x][y]=='^')
        {
            if (x==1) break;
            x--;
            continue;
        }
        if (way[x][y]=='>')
        {
            if (y==m) break;
            y++;
            continue;
        }
        if (way[x][y]=='v')
        {
            if (x==n) break;
            x++;
            continue;
        }
        if (way[x][y]=='<')
        {
            if (y==1) break;
            y--;
            continue;
        }
    }
    return cnt;
}

int main ()
{
    Init ();
    cin>>q;
    vector <int> v;
    for (int i=0; i<q; i++)
    {
        int sx, sy, cx, cy;
        char cd;
        cin>>sx>>sy>>cx>>cy>>cd;
        old=way[cx][cy];
        way[cx][cy]=cd;
        v.push_back(Find_Way(sx, sy));
        way[cy][cy]=old;
    }
    for (int i=0; i<q; i++)
        cout<<v[i]<<endl;
    return 0;
}

/*
3 4
>>v>
><v>
^>>^
4
2 1 1 1 ^
2 1 2 2 >
2 1 2 1 <
1 1 2 4 ^

4 10
>^>vv>>v^<
^<^>vv^v>^
>>v<vv^>><
v<<v>>v<vv
*/
