#include <iostream>
#include <cmath>
using namespace std;

const unsigned long long int del = 1e9 + 7;

unsigned long long int* GetNewArray(unsigned long long int array[],unsigned long long int N)
{
    unsigned long long int newArray[N];

    for(unsigned long long int i=0;i<N;i++)
    {
        newArray[i] = array[i];
    }

    return newArray;
}

unsigned long long int GetPossibilities(unsigned long long int index, unsigned long long int array[],unsigned long long int N,unsigned long long int K)
{
    if(index == N - 1)
    {
        if(array[N] != 0) return 1;
        return K - 1;
    }

    if(index == 0)
    {
        unsigned long long int sum = 0;
        if(array[0] == 0)
        {
            if(array[1] != 0)
            {
                for(int i=1;i<=K;i++)
                {
                    if(i == array[1]) continue;
                    unsigned long long int newArrayV[N];
                    for(unsigned long long int i=0;i<N;i++)
                    {
                        newArrayV[i] = array[i];
                    }
                    newArrayV[0] = i;
                    sum += GetPossibilities(index + 1, newArrayV, N,K);
                }
            }
            else if(array[1] == 0)
            {
                for(int i=1;i<=K;i++)
                {
                    unsigned long long int newArrayV[N];
                    for(unsigned long long int i=0;i<N;i++)
                    {
                        newArrayV[i] = array[i];
                    }
                    newArrayV[0] = i;
                    sum += GetPossibilities(index + 1, newArrayV, N,K);
                }
            }
            return sum;
        }
        else
        {
            return GetPossibilities(index + 1, GetNewArray(array,N),N,K);
        }
    }
    unsigned long long int sum = 0;

    for(int i=1;i<=K;i++)
        {
            if(array[index - 1] == array[index + 1])
            {
                if(i == array[index - 1]) continue;
                unsigned long long int newArrayV[N];
                    for(unsigned long long int i=0;i<N;i++)
                    {
                        newArrayV[i] = array[i];
                    }
                newArrayV[index] = i;
                sum += GetPossibilities(index + 1, newArrayV, N,K);
            }
            if(array[index - 1] != array[index + 1] && array[index + 1] != 0)
            {
                if(i == array[index - 1] || i == array[index + 1]) continue;
                unsigned long long int newArrayV[N];
                    for(unsigned long long int i=0;i<N;i++)
                    {
                        newArrayV[i] = array[i];
                    }
                newArrayV[index] = i;
                sum += GetPossibilities(index + 1, newArrayV, N,K);
            }
            if(array[index - 1] != array[index + 1] && array[index + 1] == 0)
            {
                if(i == array[index - 1]) continue;
                unsigned long long int newArrayV[N];
                    for(unsigned long long int i=0;i<N;i++)
                    {
                        newArrayV[i] = array[i];
                    }
                newArrayV[index] = i;
                sum += GetPossibilities(index + 1, newArrayV, N,K);
            }
        }
        return sum;
}

int main()
{
    unsigned long long int N,K;

    cin>>N>>K;

    unsigned long long int stones[N];

    bool haszero = false, isOnlyzero = true;

    for(int i=0;i<N;i++)
    {
        cin>>stones[i];
        if(stones[i] != 0) isOnlyzero = false;
        if(stones[i] == 0) haszero = true;
    }

    if(haszero == false)
    {
        cout<<0<<endl;
        return 0;
    }

    if(N == 1 && stones[0] == 0)
    {
        cout<<K<<endl;
        return 0;
    }
    if(N == 1 && stones[0] != 0)
    {
        cout<<0<<endl;
        return 0;
    }

    cout<<GetPossibilities(0,stones,N,K);
    return 0;
}
