#include <iostream>

using namespace std;
unsigned long long int N,M;


bool IsIn(unsigned long long int N,unsigned long long int M,unsigned long long int x,unsigned long long int y)
{
    return x >= 0 && x < N && y >=0 && y < M;
}


int main()
{
    cin>>N>>M;

    char lab[N][M];
    for(unsigned long long int i=0;i<N;i++)
    {
        for(unsigned long long int j=0;j<M;j++)
        {
            cin>>lab[i][j];
        }
    }
    unsigned long long int Q;
    cin>>Q;
    cout<<Q<<endl;
    unsigned long long int tests[Q][4];
    char testsPoska[Q];

    for(unsigned long long int i=0;i<Q;i++)
    {
        for(unsigned long long int j=0;j<4;j++)
        {
            cin>>tests[i][j];
        }

        cin>>testsPoska[i];
    }
    char labInitial[N][M];
    for(unsigned long long int i=0;i<N;i++)
    {
        for(unsigned long long int j=0;j<M;j++)
        {
            labInitial[i][j] = lab[i][j];
        }
    }

    for(int i=0;i<Q;i++)
    {
        unsigned long long int currPosX = tests[i][0]-1,currPosY = tests[i][1]-1;
        lab[tests[i][2]-1][tests[i][3]-1] = testsPoska[i];
        bool isEnd = false;
        for(int moves = 1;moves < 1000 && isEnd == false; moves++)
        {
            switch(lab[currPosX][currPosY])
            {
                case '<':
                currPosY--;
                    if(!IsIn(N,M,currPosX,currPosY))
                    {
                        cout<<moves<<endl;
                        isEnd = true;
                    }
                break;
                 case '>':
                 currPosY++;
                    if(!IsIn(N,M,currPosX,currPosY))
                    {
                        cout<<moves<<endl;
                        isEnd = true;
                    }
                break;
                 case 'v':
                 currPosX++;
                    if(!IsIn(N,M,currPosX,currPosY))
                    {
                        cout<<moves<<endl;
                        isEnd = true;
                    }
                break;
                 case '^':
                 currPosX--;
                    if(!IsIn(N,M,currPosX,currPosY))
                    {
                        cout<<moves<<endl;
                        isEnd = true;
                    }
                break;
            }
        }
        if(isEnd == false)
        {
            cout<<0<<endl;
        }
        for(unsigned long long int i=0;i<N;i++)
        {
            for(unsigned long long int j=0;j<M;j++)
            {
                lab[i][j] = labInitial[i][j];
            }
        }
    }
    return 0;
}
