#include <iostream>

static inline int factorial(int n)
{
	if(n == 0) return 1;
	if(n != 0) return n * factorial(n - 1);
}

int main(void)
{
	int pebbles_count, colors_count;
	std::cin >> pebbles_count >> colors_count;

	int const N = pebbles_count;
	int const K = colors_count;
	char* const pebbles = new char[N + 1];

	for(int i = 0;i < N; ++i) {
        std::cin >> pebbles[i];
	}

	int available_colours = K;
	int number_of_ways = 0;
	for (int i = 0; i < N; ++i) {
        if(pebbles[i] == '0') {
            number_of_ways += factorial(available_colours);
            available_colours -= 1;
        }
        else {
            available_colours = K - 1;
        }
	}

	std::cout << number_of_ways;

	delete[] pebbles;
}




