#include <iostream>
#include <cmath>

static inline int factorial(int n)
{
	if(n == 0) return 1;
	if(n != 0) return n * factorial(n - 1);
}

int main(void)
{
	int pebbles_count, colors_count;
	std::cin >> pebbles_count >> colors_count;

	int const N = pebbles_count;
	int const K = colors_count;
	char* const pebbles = new char[N + 1];

	for(int i = 0;i < N; ++i) {
        std::cin >> pebbles[i];
	}

	int available_colours = K;
	int number_of_ways = 1;

	for (int i = 0; i < N; ++i) {
        if(i + 1 < N && pebbles[i + 1] != '0') {
            available_colours -= 1;
        }
        if(i - 1 >= 0 && pebbles[i - 1] != '0') {
            available_colours -= 1;
        }
        if(i - 1 >= 0 && i + 1 < N && pebbles[i - 1] == pebbles[i + 1]) {
            available_colours += 1;
        }
        if(pebbles[i] == '0') {
            number_of_ways *= available_colours;
        }

        available_colours = K;
	}

    long long int a = (pow(10, 9) + 7);
	std::cout << number_of_ways % a;

	delete[] pebbles;
}




