#include<iostream>
#include <cmath>

using namespace std;

class Person{
    public:
        int start;
        int end;
};

int main()
{
    int N = 0;
    int M = 0;
    cin >> N;
    cin >> M;

    Person people[N];
    int lastExit = 0;
    for(int i = 0; i < N; i++)
    {
        cin >> people[i].start;
        cin >> people[i].end;

        if(lastExit < people[i].end)
        {
            lastExit = people[i].end;
        }
    }

    int maxSum = 0;
    int maxMinute = 0;
    for(int i = 1; i <= lastExit - M; i++)
    {
        int sum = 0;
        for(int j = 0; j < N; j++)
        {
            int start = people[j].start;
            int end = people[j].end;

            if(start <= i && end >= i + M)
            {
                sum++;
            }
        }

        if(sum > maxSum)
        {
            maxSum = sum;
            maxMinute = i;
        }
    }

    int secondSum = 0;
    int allocatedTime = maxMinute + M;
    for(int i = 1; i <= lastExit - M; i++)
    {
        if(i + M > maxMinute && i < allocatedTime)
        {
            continue;
        }

        int sum = 0;
        for(int j = 0; j < N; j++)
        {
            int start = people[j].start;
            int end = people[j].end;

            if(start <= i && end >= i + M)
            {
                sum++;
            }
        }

        if(sum > secondSum)
        {
            secondSum = sum;
        }
    }

    cout << maxSum + secondSum;
}
