#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

class Coords {
    public:
        short int X;
        short int Y;
};

int main()
{
    short int N;
    short int M;

    cin >> N;
    cin >> M;

    char maze[N][M];

    for(int i = 0; i < N; i++)
    {
        cin >> maze[i];
    }

    int Q;

    cin >> Q;

    short int Sx;
    short int Sy;
    short int Cx;
    short int Cy;
    char symbol;



    for(int test = 0; test < Q; test++)
    {
        cin >> Sx;
        cin >> Sy;
        cin >> Cx;
        cin >> Cy;
        cin >> symbol;

        char mazeClone[N][M];
        for(int i = 0; i < N; i++)
        {
            for(int j = 0; j < M; j++)
            {
                mazeClone[i][j] = maze[i][j];
            }
        }

        mazeClone[Cx-1][Cy-1] = symbol;

        vector<Coords> path;

        int sum = 0;
        while(true)
        {
            char currentSymbol = mazeClone[Sx-1][Sy-1];
            if(currentSymbol == '>')
            {
                Sy++;
            }
            else if(currentSymbol == '<')
            {
                Sy--;
            }
            else if(currentSymbol == 'v')
            {
                Sx++;
            }
            else if(currentSymbol == '^')
            {
                Sx--;
            }

            sum++;

            if(Sx-1 == N || Sy-1 == M || Sx-1 < 0 || Sy-1 < 0)
            {
                cout << sum << '\n';
                break;
            }

            bool flag = false;
            for(int i=0; i < path.size(); i++){
                if(path[i].X == Sx-1 && path[i].Y == Sy-1)
                {
                    cout << 0 << '\n';
                    flag = true;
                    break;
                }
            }

            if(flag)
            {
                break;
            }

            Coords coords;
            coords.X = Sx-1;
            coords.Y = Sy-1;
            path.push_back(coords);
        }
    }

}
