#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<vector>
using namespace std;

struct Person
{
    int a, b;

    Person(int a, int b) {this->a = a; this->b = b;}
};

bool operator< (Person a, Person b)
{
    if (a.a < b.a) return true;
    else if (a.a > b.a) return false;
    else return a.b < b.b;
}

int n, m;

vector<Person> people;
vector<int> listeners;
vector<int> nextAvailable;

int main ()
{
    scanf("%d%d", &n, &m);

    int leftP = 0;
    for (int i=0; i<n; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        people.emplace_back(a, b);


    }
    sort(people.begin(), people.end());

    for (int i=0; i<n; i++)
    {
        if (leftP == i) continue;
        while (people[leftP].a + m <= people[i].a)
        {
            nextAvailable.push_back(i);
            leftP++;
        }
    }

    while (nextAvailable.size() < n) nextAvailable.push_back(-1);

    vector<int> best;

    for (int i=0; i<n; i++)
    {
        int amount = 0;

        for (int j=0; j<n; j++)
        {
            if (people[j].a > people[i].a) break;

            if (people[i].a + m <= people[j].b) amount++;
        }

        listeners.push_back(amount);
        //blank
        best.push_back(0);
    }

    best[n-1] = listeners[n-1];
    for (int i=n-2; i>=0; i--) best[i] = max(listeners[i], best[i+1]);

    int ans = 0;

//    for (int i=0; i<n; i++)
//    {
//        cout<<i<<" "<<listeners[i]<<" "<<best[i]<<endl;
//    }

    for (int i=0; i<n; i++)
    {
        if (nextAvailable[i] == -1) continue;
        int followingListeners = 0;
        for (int j=0; j<n; j++)
        {
            if (people[j].a > people[i].a + m) break;

            if (people[i].a + 2*m <= people[j].b) followingListeners++;
        }
        ans = max(ans, listeners[i] + max(followingListeners, best[nextAvailable[i]]));
    }
    cout<<ans<<endl;
}
