#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<map>
#include<vector>
using namespace std;

struct Person
{
    int a, b;

    Person(int a, int b) {this->a = a; this->b = b;}
};

bool operator< (Person a, Person b)
{
    if (a.a < b.a) return true;
    else if (a.a > b.a) return false;
    else return a.b < b.b;
}

int n, m;

vector<Person> people;
vector<int> listeners;
vector<int> nextAvailable;

map<int, int> preCounted;

int CountFrom(int x)
{
    if (preCounted.find(x) != preCounted.end()) return preCounted[x];

    int ret = 0;
    for (int i=0; i<people.size(); i++)
    {
        if (people[i].a <= x && x + m <= people[i].b) ret++;
    }

    preCounted[x] = ret;
    return ret;
}

int main ()
{
    scanf("%d%d", &n, &m);

    int leftP = 0;
    for (int i=0; i<n; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        people.emplace_back(a, b);
    }

    if (m > 1)
    {
    sort(people.begin(), people.end());
    int theans = 0;
    for (int i=0; i<n; i++)
    {
        int cur = CountFrom(people[i].a);
        theans = max(theans, cur + CountFrom(people[i].a+m));
        for (int j=0; j<n; j++)
        {
            if (people[i].a + m > people[j].a) continue;
            theans = max(theans, cur + CountFrom(people[j].a));
        }
    }
    cout<<theans<<endl;
    return 0;
    }

    vector<pair<int, bool> > positions;
    for (int i=0; i<people.size(); i++)
    {
        positions.emplace_back(people[i].a, true);
        positions.emplace_back(people[i].b, false);
    }
    sort(positions.begin(), positions.end());

    int amount;

    vector<pair<int, int> > sections;

    int counter = 1;

    for (int i=1; i<positions.size(); i++)
    {
        if (positions[i].first != positions[i-1].first)
        {
            sections.emplace_back(counter, positions[i].first - positions[i-1].first);
        }

        if (positions[i].second) counter++;
        else counter--;
    }

    sort(sections.begin(), sections.end());

    if (sections[sections.size()-1].second > 1)
    {
        cout<<sections[sections.size()-1].first*2<<endl;
    }
    else
    {
        cout<<sections[sections.size()-1].first + sections[sections.size()-2].first<<endl;
    }

    //for (int i=0; i<positions.size(); i++) cout<<positions[i].first<<" "<<positions[i].second<<endl;

    return 0;
}

/**

4 1
1 12
4 11
6 15
2 7


*/
