#include<iostream>
#include<cstdio>
#include<set>
#include<vector>
using namespace std;

int n, m, q;

vector<string> maze;

int main()
{
    scanf("%d%d", &n, &m);

    for (int i=0; i<n; i++)
    {
        string s;
        cin>>s;
        maze.push_back(s);
    }

    scanf("%d", &q);

    for (int qrs = 0; qrs < q; qrs++)
    {
        int startx, starty, changex, changey;
        char newC, oldC;
        scanf("%d%d%d%d", &startx, &starty, &changex, &changey);
        startx--;
        starty--;
        changex--;
        changey--;
        cin>>newC;
        oldC = maze[changex][changey];
        maze[changex][changey] = newC;

        //for (int i=0; i<n; i++) cout<<maze[i]<<endl;

        set<pair<int, int> > explored;
        int ans = 0;
        while (explored.count(make_pair(startx, starty)) == 0)
        {
            //cout<<startx<<" "<<starty<<endl;
            ans++;
            explored.emplace(startx, starty);

            if (maze[startx][starty] == '>') starty++;
            else if (maze[startx][starty] == '<') starty--;
            else if (maze[startx][starty] == 'v') startx++;
            else if (maze[startx][starty] == '^') startx--;
            //else cout<<"sadge"<<endl;

            if (startx < 0 || startx >= n || starty < 0 || starty >= m)
            {
                cout<<ans<<endl;
                break;
            }
        }

        if (explored.count(make_pair(startx, starty)) > 0)
        {
            cout<<0<<endl;
        }

        maze[changex][changey] = oldC;
    }
}
