#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const ll MOD = 1e9 + 7;
const int N = 5e5 + 3;

int n, k, a[N];
ll dp[N][5];

void init_dp(){
    for(int i = 0; i <= n; ++i){
        for(int j = 0; j < 5; ++j){
            if(i == 0){
                dp[i][j] = (j != 4);
                continue;
            }

            if(j == 0){
                dp[i][j] = dp[i - 1][2] * k % MOD;
                continue;
            }
            if(j == 1){
                dp[i][j] = dp[i - 1][3] * (k - 1) % MOD;
                dp[i][j] = (dp[i][j] + dp[i - 1][4]) % MOD;
                continue;
            }
            if(j == 2){
                dp[i][j] = dp[i - 1][2] * (k - 1) % MOD;
                continue;
            }
            if(j == 3){
                dp[i][j] = dp[i - 1][3] * (k - 2) % MOD;
                dp[i][j] = (dp[i][j] + dp[i - 1][4]) % MOD;
                continue;
            }
            if(j == 4){
                dp[i][j] = dp[i - 1][3] * (k - 1) % MOD;
                continue;
            }
        }
    }
}

ll solve(int n, int c1, int c2){
    if(!c1 && !c2) return dp[n][0];
    if(!c1 && c2) return dp[n][1];
    if(c1 && !c2) return dp[n][2];
    if(c1 != c2) return dp[n][3];
    return dp[n][4];
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    init_dp();

    int prev = 0, idx = -1;
    ll ans = 1;
    for(int i = 0; i < n; ++i){
        if(a[i]){
            if(idx != i - 1)
                ans = ans * solve(i - idx - 1, prev, a[i]) % MOD;
            prev = a[i];
            idx = i;
        }
    }
    if(idx != n - 1)
        ans = ans * solve(n - idx - 1, prev, 0) % MOD;

    cout << ans;
}
