#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back

using namespace std;

const int N = 1500;
int n, m;
char matrix[N][N];
bool used[N][N];

void input() {
    cin>>n>>m;
    for (int i=0; i<n; i++) {
        for (int j=0; j<m; j++) {
            cin>>matrix[i][j];
        }
    }
}

int calcFor(int x, int y) {
    int px = x, py = y;
    int cnt = 0;
    bool val = 0;
    while (!used[x][y]) {
        cnt++;
        used[x][y] = 1;
        if (matrix[x][y] == '^') {
            x--;
        } else if (matrix[x][y] == '>') {
            y++;
        } else if (matrix[x][y] == '<') {
            y--;
        } else {
            x++;
        }
        if (x < 0 || x >= n || y < 0 || y >= m) {
            val = 1;
            break;
        }
    }
    x = px, y = py;
    while (used[x][y]) {
        used[x][y] = 0;
        if (matrix[x][y] == '^') {
            x--;
        } else if (matrix[x][y] == '>') {
            y++;
        } else if (matrix[x][y] == '<') {
            y--;
        } else {
            x++;
        }
        if (x < 0 || x >= n || y < 0 || y >= m) {
            break;
        }
    }
    if (val) {
        return cnt;
    }
    return 0;
}

void solve() {
    int q;
    cin>>q;
    int x, y, x2, y2;
    char nd;
    while (q--) {
        cin>>x>>y>>x2>>y2>>nd;
        char temp = matrix[x2-1][y2-1];
        matrix[x2-1][y2-1] = nd;
        cout<<calcFor(x-1, y-1)<<'\n';
        matrix[x2-1][y2-1] = temp;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    return 0;
}

/*
3 4
>>v>
><v>
^>>^
1
1 1 2 4 ^

3 4
>>v>
><v>
^>>^
4
2 1 1 1 ^
2 1 2 2 >
2 1 2 1 <
1 1 2 4 ^
*/
