#include <iostream>
#define mod 1000000007
using namespace std;

int n, a [500005];
long long k, dp_same [500005][2], dp_not_same [500005][2];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> k;
    for (int i = 0; i < n; i ++) cin >> a [i];

    if (n == 1){
        if (a [0] == 0) cout << k << '\n';
        else cout << "1\n";
        return 0;
    }

    dp_not_same [0][1] = 1;
    dp_same [1][0] = 0;
    dp_same [1][1] = k - 1;
    dp_not_same [1][0] = 1;
    dp_not_same [1][1] = k - 2;
    for (int i = 2; i <= n; i ++){
        dp_same [i][0] = dp_same [i - 1][1];
        dp_same [i][1] = (dp_same [i - 1][0] * (k - 1) + dp_same [i - 1][1] * (k - 2)) % mod;
        dp_not_same [i][0] = dp_not_same [i - 1][1];
        dp_not_same [i][1] = (dp_not_same [i - 1][0] * (k - 1) + dp_not_same [i - 1][1] * (k - 2)) % mod;
    }

    long long ans;
    int l;
    for (l = 0; l < n; l ++){
        if (a [l] != 0) break;
    }
    if (l == n) ans = (k * dp_same [l - 2][1] + k * (k - 1) % mod * dp_not_same [l - 2][1]) % mod;
    else if (l > 0) ans = (dp_same [l - 1][1] + (k - 1) * dp_not_same [l - 1][1]) % mod;
    else ans = 1;

    for (++l; l < n; l ++){
        int i;
        for (i = l; i < n; i ++){
            if (a [i] != 0) break;
        }
        if (i == n) ans = (dp_same [i - l - 1][1] + (k - 1) * dp_not_same [i - l - 1][1]) % mod * ans % mod;
        else if (a [i] == a [l - 1]) ans = ans * dp_same [i - l][1] % mod;
        else ans = ans * dp_not_same [i - l][1] % mod;
        l = i;
    }
    cout << ans << '\n';

}
