#include<bits/stdc++.h>
#define ull unsigned long long
#pragma optimize GCC Ofast
using namespace std;

/// twitch.tv/bili220022

int n,u,v, m;
vector<pair<int,int>> people;

int measure(int k1, int k2) {
    if(k1 + m > k2) {
        return 0;
    }
    int res = 0;
    for(auto p : people) {
        if(p.first <= k1 and p.second >= k1 + m) {
            res++;
        }
        if(p.first <= k2 and p.second >= k2 + m) {
            res++;
        }
    }
    return res;
}
set<int> timesToStart;
int max1pos = -1, max2pos = -1;
unordered_map<int, int> results;


void tryNewMax(int pos) {
    if(pos == max1pos) {

    }
    else if(max1pos == -1) {
        max1pos = pos;
    }
    else if(max2pos == -1) {
        max2pos = pos;
    }
    else if(max2pos == max1pos and results[max1pos] == results[max2pos]) {
        swap(max1pos, max2pos);
    }
    else if (results[pos] > results[max2pos]) {
        max2pos = pos;
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    cin>>m;
    timesToStart.insert(0);
    for(int i = 0 ; i < n ; i++) {
        cin>>u>>v;
        if(v-u >= m) {
            people.push_back({u,v});
            timesToStart.insert(u);
            timesToStart.insert(u+1);
        }
    }
    if(m != 1) {
        int res = 0;
        for(int k1 : timesToStart) {
            for(int k2 : timesToStart) {
                if(k1 > k2) {
                    continue;
                }
                res = max(res, measure(k1, k2));
                res = max(res, measure(k1, k1 + m));
            }
        }
        cout<<res<<endl;
        return 0;
    }

    for(auto p : people) {
        auto iter = timesToStart.find(p.first);
        while(iter != timesToStart.end()) {
            if((*iter) >= p.second) {
                //cout<<"person"<< p.first<<","<<p.second<<"cannot listen to a song that starts at:"<< (*iter)<<endl;
                break;
            }
            //cout<<"person"<< p.first<<","<<p.second<<"can listen to a song that starts at:"<< (*iter)<<endl;
            results[(*iter)]++;
            tryNewMax((*iter));
            iter++;
        }
    }
    //cout<<max1pos<<endl;
    //cout<<max2pos<<endl;
    cout<<results[max1pos] + results[max2pos]<<endl;
}
