#include<bits/stdc++.h>
#define ull unsigned long long
#pragma optimize GCC Ofast
const ull mod = 1000000007;
using namespace std;

/// twitch.tv/bili220022
ull n;
ull k;
ull memoization[3000];

ull power(ull base, ull pwr) {
    ull res = 1;
    while(pwr != 0) {
        if(pwr & 1 != 0) {
            res *= base;
            res = res % mod;
        }
        pwr = pwr >> 1;
        base = (base * base ) % mod;
    }
    return res;
}

ull solve(ull cnt, bool same) {
    if(cnt == 0) {
        return !same;
    }
    if(same) {
        return ((k-1) * solve(cnt - 1, false)) % mod;
    }
    if(memoization[cnt]) {
        return memoization[cnt];
    }
    ull res = 0;
    res += ((k - 2) * solve(cnt - 1, false)) % mod;
    res = res % mod;
    res += (solve(cnt - 1, true)) % mod;
    res = res % mod;
    memoization[cnt] = res;
    //cout<<"mem["<<cnt<<"]="<<res<<endl;
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>k;
    int cnt = 0;
    int curr;
    int before_color = 0;
    int after_color = 0;
    ull mult;
    ull res = 1;
    int i;
    for(i = 0; i < n; i++) {
        cin>>curr;
        if(curr == 0) {
            cnt++;
        }
        else {
            before_color = after_color;
            after_color = curr;
            res = power(k-1, cnt);
            //cout<<"prefix:" << res<<endl;
            res = res % mod;
            cnt = 0;
            i++;
            break;
        }
    }
    if(i == n) { // all empty
        res = (power(k-1, n - 1) * k) % mod;
        cout<<res<<endl;
        return 0;
    }
    // atleast 1
    for(; i < n; i++) {
        cin>>curr;
        if(curr == 0) {
            cnt++;
        }
        else {
            before_color = after_color;
            after_color = curr;
            mult = solve(cnt, after_color == before_color);
            res = (res * mult) % mod;
            //cout<<"twosided:" << mult<<endl;
            res = res % mod;
            cnt = 0;
        }
    }
    ///ending
    res = (res * power(k - 1, cnt)) % mod;
    cout<<res<<endl;
    return 0;
}

