#include<iostream>
#include<stack>
#define calci(x,y) (y*2000+x)
using namespace std;
char tab[2000][2000];
int dist[4000000];
int nxt[4000000];
bool visited[4000000];
bool cycle[4000000];
/*int calci(int x,int y)
{
    return y*2000+x;
}*/
int lifting[4000000][30];
int n,m;
void dfs(int x,int y)
{

}
int lift(int i,int h)
{
    for(int j=20; j>=0; j--)
    {
        while((1<<j)<=h)
        {
            h-=(1<<j);
            i=lifting[i][j];
        }
    }
    return i;
}
int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int q;
    cin>>n>>m;
    for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            cin>>tab[x][y];
        }
    }
    for(int y0=0; y0<n; y0++)
    {
        for(int x0=0; x0<m; x0++)
        {
            int i=calci(x0,y0);
            if(!visited[i])
            {
                int x=x0;
                int y=y0;
                stack<int>path;
                while(1)
                {
                    int i=calci(x,y);
                    visited[i]=1;
                    path.push(i);
                    int x1=x,y1=y;
                    switch(tab[x][y])
                    {
                    case '<':
                        x1--;
                        break;
                    case '>':
                        x1++;
                        break;
                    case '^':
                        y1--;
                        break;
                    case 'v':
                        y1++;
                        break;
                    }
                    if(x1<0 || x1>=m || y1<0 || y1>=n)
                    {
                        nxt[i]=-1;
                        dist[i]=1;
                        break;
                    }
                    int i1=calci(x1,y1);
                    if(visited[i1] && dist[i1]==0)
                    {
                        cycle[i]=1;
                        nxt[i]=-1;
                        dist[i]=1;
                        break;
                    }
                    if(!visited[i1])
                    {
                        x=x1;
                        y=y1;
                        continue;
                    }
                    else
                    {
                        path.push(i1);
                        break;
                    }
                    /*nxt[i]=i1;
                    cycle[i]=cycle[i1];
                    dist[i]=dist[i1]+1;*/
                }
                int last=path.top();
                path.pop();
                while(!path.empty())
                {
                    int curr=path.top();
                    path.pop();
                    nxt[curr]=last;
                    cycle[curr]=cycle[last];
                    dist[curr]=dist[last]+1;
                    last=curr;
                }
            }
            else
            {
                //cout<<"a";
            }
        }
    }
    /*
    for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            int i=calci(x,y);
            if(cycle[i])
            {
                cout<<0;
            }
            else
            {
                cout<<dist[i];
            }
            cout<<" ";
        }
        cout<<endl;
    }
    */
    for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            int i=calci(x,y);
            lifting[i][0]=nxt[i];
        }
    }
    for(int j=1; j<20; j++)
    {
        for(int y=0; y<n; y++)
        {
            for(int x=0; x<m; x++)
            {
                int i=calci(x,y);
                if(lifting[i][j-1]!=-1)
                {
                    lifting[i][j]=lifting[lifting[i][j-1]][j-1];
                }
                else
                {
                    lifting[i][j]=-1;
                }
            }
        }
    }
    /*for(int j=0; j<3; j++)
    {
        for(int y=0; y<n; y++)
        {
            for(int x=0; x<m; x++)
            {
                int i=calci(x,y);
                cout<<lifting[i][j]<<" ";
            }
            cout<<endl;
        }
        cout<<endl;
    }*/
    cin>>q;
    for(int i=0; i<q; i++)
    {
        int sx,sy,x,y;
        char sign;
        cin>>sy>>sx>>y>>x>>sign;
        sy--;
        sx--;
        y--;
        x--;
        int si=calci(sx,sy),ci=calci(x,y);
        int diff=dist[si]-dist[ci];
        int anc=-1;
        if(diff>=0)
        {
            anc=lift(si,diff);
        }
        if(diff<0 || anc!=ci)
        {
            if(cycle[si])
            {
                cout<<0;
            }
            else
            {
                cout<<dist[si];
            }
            cout<<"\n";
        }
        else
        {
            //int dist=diff;
            int x1=x,y1=y;
            switch(sign)
            {
            case '<':
                x1--;
                break;
            case '>':
                x1++;
                break;
            case '^':
                y1--;
                break;
            case 'v':
                y1++;
                break;
            }
            if(x1<0 || x1>=m || y1<0 || y1>=n)
            {
                cout<<diff+1<<"\n";
                continue;
            }
            int i1=calci(x1,y1);
            int diff1=dist[i1]-dist[ci];
            int anc1=-1;
            if(diff1>=0)
            {
                anc1=lift(i1,diff1);
            }
            //cout<<i<<" "<<i1<<" "<<anc1<<endl;
            if(diff>=0 && anc1==ci)
            {
                cout<<0<<"\n";
            }
            else
            {
                cout<<diff+1+dist[i1]<<"\n";
            }
        }
    }
    std::cout.flush();
    return 0;
}
