#include <bits/stdc++.h>
#define endl '\n'
#define INF 1000000007;
using namespace std;

int customerCalc(int x, int y, vector<pair<int, int>> time) {
    int total = 0;

    for (auto u: time) {
        if (x >= u.first && y <= u.second) total++;
    }

    return total;
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int maxAds;

    int N, M;
    cin >> N >> M;

    vector<pair<int, int>> customerTime;
    vector<pair<int, int>> pointsOnLine;
    int defaultPointsOnLine[N * 2];

    for (int i = 0, A, B; i < N; i++) {
        cin >> A >> B;
        customerTime.push_back({A, B});
        pointsOnLine.push_back({0, A});
        pointsOnLine.push_back({0, B});
        defaultPointsOnLine[i * 2] = A;
        defaultPointsOnLine[i * 2 + 1] = B;
    }

    int adX, adY;
    for (vector<pair<int, int>>::iterator it = pointsOnLine.begin(); it != pointsOnLine.end(); it++) {
        adX = it->second;
        adY = adX + M;
        it->first = customerCalc(adX, adY, customerTime);
    }
    for (vector<pair<int, int>>::iterator it = pointsOnLine.end() - 1; it != pointsOnLine.begin() - 1; it--) {
        adY = it->second;
        adX = adY - M;
        it->first = max(it->first, customerCalc(adX, adY, customerTime));
    }

    sort(pointsOnLine.begin(), pointsOnLine.end());

    for (vector<pair<int, int>>::iterator it = pointsOnLine.end() - 1; it != pointsOnLine.begin() - 1; it--) {
        maxAds = it->first;
        for (vector<pair<int, int>>::iterator newIt = pointsOnLine.end() - 1; newIt != pointsOnLine.begin() - 1; newIt--) {
            int small, big, lowerBound, upperBound;

            small = it->second;
            big = newIt->second;
            if (small > big) swap(small, big);

            for (int i = 0; i < N * 2; i++) {
                if (defaultPointsOnLine[i] == small && i != 0) lowerBound = defaultPointsOnLine[i - 1];
                if (defaultPointsOnLine[i] == small && i == 0) lowerBound = -INF;
                if (defaultPointsOnLine[i] == big && i != N * 2 - 1) {upperBound = defaultPointsOnLine[i + 1]; break;}
                if (defaultPointsOnLine[i] == big && i == N * 2 - 1) upperBound = INF;
            }

            if (upperBound - lowerBound - 2 < 2 * M) continue;

            maxAds += newIt->first;

            cout << maxAds << endl;
            return 0;
        }
    }
}
