#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

int N, M;
char maze[1501][1501];
char mazeActive[1501][1501];
int trav;

void resetActiveMaze() {
    for (int i = 1; i <= N; i++) {
        for (int j = 1; j <= M; j++) {
            mazeActive[i][j] = maze[i][j];
        }
    }
}

void dfs(int x, int y) {
    switch (mazeActive[x][y]) {
    case '<':
        trav++;
        mazeActive[x][y] = '#';
        if (!(y - 1 < 1)) {
            if (mazeActive[x][y - 1] != '#') {
                dfs(x, y - 1);
            } else {
                trav = 0;
            }
        }
        break;
    case '>':
        trav++;
        mazeActive[x][y] = '#';
        if (!(y + 1 > M)) {
            if (mazeActive[x][y + 1] != '#') {
                dfs(x, y + 1);
            } else {
                trav = 0;
            }
        }
        break;
    case '^':
        trav++;
        mazeActive[x][y] = '#';
        if (!(x - 1 < 1)) {
            if (mazeActive[x - 1][y] != '#') {
                dfs(x - 1, y);
            } else {
                trav = 0;
            }
        }
        break;
    case 'v':
        trav++;
        mazeActive[x][y] = '#';
        if (!(x + 1 > N)) {
            if (mazeActive[x + 1][y] != '#') {
                dfs(x + 1, y);
            } else {
                trav = 0;
            }
        }
        break;
    }
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    vector<int> vecAnswers;

    cin >> N >> M;

    for (int i = 1; i <= N; i++) {
        for (int j = 1; j <= M; j++) {
            cin >> maze[i][j];
        }
    }

    int testCount;
    cin >> testCount;

    int xT, yT, xP, yP;
    char symbol;

    for (int i = 0; i < testCount; i++) {
        cin >> xT >> yT >> xP >> yP >> symbol;
        trav = 0;

        resetActiveMaze();
        mazeActive[xP][yP] = symbol;
        dfs(xT, yT);

        vecAnswers.push_back(trav);
    }

    for(auto u: vecAnswers) {
        cout << u << endl;
    }

    return 0;
}
