#include<iostream>
#include<vector>
#include<utility>
#include<set>
#include<algorithm>
using namespace std;

const int Max_N=300100;

//struct segment_tree{
//
//    struct node{
//        node * l;
//        node * r;
//
//        int num_in;
//        vector<int> l;
//        vector<int> r;
//
//    };
//
//    node root;
//
//
//
//};

int n,m,res;
pair<int,int> vis[Max_N];

vector<int> p_st;

vector<int> h_l;
vector<int> h_r;

vector<int> v_st;

vector<int> l_min_v_st;
vector<int> r_min_v_st;

void calc_p_st(){
    set<int> s;
    for(int i=0;i<n;i++){
        s.insert(vis[i].first);
        s.insert(max(0,vis[i].second-m));
    }
    set<int>::iterator i;
    for(i=s.begin();i!=s.end();i++){
        p_st.push_back((*i));
    }
//    cout<<endl;
//    for(int i=0;i<p_st.size();i++){
//        cout<<p_st[i]<<endl;
//    }
    return;
}

void calc_v_st(){
    v_st.resize(p_st.size());
    l_min_v_st.resize(p_st.size());
    r_min_v_st.resize(p_st.size());
    for(int i=0;i<p_st.size();i++){
        for(int j=0;j<n;j++){
            if( (p_st[i]>=vis[j].first) and ( vis[j].second>=(p_st[i]+m) ) ){
                v_st[i]++;
            }
        }
    }

    l_min_v_st[0]=v_st[0];
    for(int i=1;i<p_st.size();i++){
        l_min_v_st[i]=max(l_min_v_st[i-1],v_st[i]);
    }
    r_min_v_st[p_st.size()-1]=v_st[p_st.size()-1];
    for(int i=p_st.size()-2;i>-1;i--){
        r_min_v_st[i]=max(r_min_v_st[i+1],v_st[i]);
    }
//    cout<<endl;
//    for(int i=0;i<v_st.size();i++){
//        cout<<v_st[i]<<endl;
//    }
//    cout<<endl;
//    for(int i=0;i<l_min_v_st.size();i++){
//        cout<<l_min_v_st[i]<<endl;
//    }
//    cout<<endl;
//    for(int i=0;i<r_min_v_st.size();i++){
//        cout<<r_min_v_st[i]<<endl;
//    }
    return;
}

void calc_res(){
    res=0;
    int tr;
    for(int i=0;i<p_st.size()-1;i++){
        for(int j=i+1;j<p_st.size();j++){
            if( (p_st[i]+m) <= (p_st[j]) ){
                tr=v_st[i]+v_st[j];
                res=max(res,tr);
            }
        }
    }
    return;
}


int main(){
    ios_base::sync_with_stdio(false);
    cin>>n>>m;
    for(int i=0;i<n;i++){
        cin>>vis[i].first>>vis[i].second;
    }
    calc_p_st();
    calc_v_st();
    calc_res();
    cout<<res;
    return 0;
}
