#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxn=2048;
int n,m,q,ans;
char ch[maxn][maxn];
int used[maxn][maxn];
map<pair<int,int>,int >mmap;
///----------------------------------------------
void read()
{
    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>ch[i][j];
        }
    }
}
///----------------------------------------------
void rec(int x, int y, int ans)
{
    //cout<<x<<" "<<y<<" "<<ans<< endl;
    if(x==0 || y==0 || x==n+1 || y==m+1)
    {
        cout<<ans<< endl;
        return;
    }
    if(!mmap[ {x,y}])
    {
        mmap[ {x,y}]=ans;
    }
    if(mmap[ {x,y}]<ans)
    {
        cout<<0<< endl;
        return;
    }
    if(ch[x][y]=='^')
        rec(x-1,y,ans+1);
    if(ch[x][y]=='v')
        rec(x+1,y,ans+1);
    if(ch[x][y]=='<')
        rec(x,y-1,ans+1);
    if(ch[x][y]=='>')
        rec(x,y+1,ans+1);
}
///----------------------------------------------
void get_ans(int tx, int ty, int sx, int sy, char symbol)
{
    mmap.clear();
    char prev;
    prev=ch[sx][sy];
    ch[sx][sy]=symbol;
    ans=0;
    rec(tx,ty,0);
    ch[sx][sy]=prev;
}
///----------------------------------------------
void find_participants(int x, int y, int cycle)
{
    if(used[x][y]==cycle)
        return;
    else
    {
        used[x][y]=cycle;
        if(ch[x][y]=='^')
            find_participants(x-1,y,cycle);
        if(ch[x][y]=='v')
            find_participants(x+1,y,cycle);
        if(ch[x][y]=='<')
            find_participants(x,y-1,cycle);
        if(ch[x][y]=='>')
            find_participants(x,y+1,cycle);
    }
}
///----------------------------------------------
void find_cycles()
{
    int cycle=1;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            if(!used[i][j])
            {
                find_participants(i,j,cycle);
                cycle++;
            }
        }
    }
}
///----------------------------------------------
void solve()
{
    int tx,ty,sx,sy;
    char symbol;
    if(n<=1500 && m<=1500 && n>100 && m>100)
    {
        find_cycles();
    }
    cin>>q;
    while(q--)
    {
        cin>>tx>>ty>>sx>>sy>>symbol;
        //cout<<q<<"/-----------------------------"<<endl;
        if(n<=100 && m<=100)
        {
            get_ans(tx,ty,sx,sy,symbol);
        }
        else if(n<=1500 && m<=1500)
        {
            if(used[tx][ty]!=used[sx][sy])
            {
                cout<<0<< endl;
            }
            else
            {
                if(sx==1 && sx==n || sy==1 || sy==m)
                get_ans(tx,ty,sx,sy,symbol);
                else
                    cout<<0<< endl;
            }
        }
    }
}
///----------------------------------------------
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}

