#include <iostream>
#include <cmath>
#include <algorithm>
#define endl '\n'
using namespace std;

long long const MAXN=10000;
long long n, m, cnt=0, q;
long long p[MAXN][MAXN], used[MAXN][MAXN];

int solution(int x, int y)
{
    if(used[x][y]!=0) return 0;
    else used[x][y]=1;
    if(x==0||y==0||x>n||y>m) return cnt;
    if(p[x][y]==1) y--;
    else if(p[x][y]==2) y++;
    else if(p[x][y]==3) x--;
    else x++;
    cnt++;
    solution(x,y);
}

void read()
{
    char ch, cd;
    int sx, sy, cx, cy, past;
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>ch;
            if(ch=='<') p[i][j]=1;
            else if(ch=='>') p[i][j]=2;
            else if(ch=='^') p[i][j]=3;
            else p[i][j]=4;
        }
    }
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        cin>>sx>>sy>>cx>>cy>>cd;
        past=p[cx][cy];
        if(cd=='<') p[cx][cy]=1;
        else if(cd=='>') p[cx][cy]=2;
        else if(cd=='^') p[cx][cy]=3;
        else p[cx][cy]=4;
        cnt=0;
        cout<<solution(sx,sy)<<endl;
        for(int j=1;j<=n;j++)
        {
            for(int k=1;k<=m;k++)
            {
                used[j][k]=0;
            }
        }
        p[cx][cy]=past;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
