#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<pair<int, int>> intervals;

void read() {
    cin >> n >> m;

    intervals.resize(n);
    for (auto &i : intervals) {
        cin >> i.first >> i.second;
    }
}

int countClients(int time) {
    int num = 0;
    for (int i = 0; i < n; i++) {
        if (time >= intervals[i].first && time + m <= intervals[i].second) {
            num++;
        }
    }

    return num;
}

void solve() {
    int maxB = 0;
    for (int i = 0; i < n; i++) {
        maxB = max(maxB, intervals[i].second);
    }

    int answer = 0;
    for (int i = 1; i <= maxB - m; i++) {
        for (int j = i + m; j <= maxB - m; j++) {
            answer = max(answer, countClients(i) + countClients(j));
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
