#include<bits/stdc++.h>
using namespace std;

int n, m, q;
vector<int> lab;
vector<bool> visited;

string s;
int si, sj, ci, cj, neib, nid;
char cd;
int index;
int steps;

int neighbour(int i, int j, char c)
{
    switch(c)
    {
        case '^':
            i--;
            break;
        case '>':
            j++;
            break;
        case 'v':
            i++;
            break;
        case '<':
            j--;
    }
    if(i >= 0 && i < n && j >= 0 && j < m) return i * m + j;
    return -1;
}

void check()
{
    steps = 0;
    visited.assign(visited.size(), false);
    while(index != -1)
    {
        if(visited[index])
        {
            cout <<0 <<"\n";
            return;
        }

        visited[index] = 1;
        steps++;
        index = (index == nid ? neib : lab[index]);
    }

    cout <<steps <<"\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n >>m;
    lab.resize(n * m);
    visited.resize(lab.size());

    int i, j, id = 0;
    for(i = 0; i < n; i++)
    {
        cin >>s;
        for(j = 0; j < m; j++, id++)
        {
            lab[id] = neighbour(i, j, s[j]);
        }
    }
    /*
    id = 0;
    for(i = 0; i < n; i++)
    {
        for(j = 0; j < m; j++, id++)
        {
            cout <<lab[id] <<" ";
        }
        cout <<"\n";
    }
    */
    cin >>q;
    for(i = 0; i < q; i++)
    {
        cin >>si >>sj >>ci >>cj >>cd;
        si--; sj--; ci--; cj--;
        index = si * m + sj;
        nid = ci * m + cj;
        neib = neighbour(ci, cj, cd);
        check();
    }
}
