#include<iostream>
using namespace std;
char matrix[1500][1500];
bool visited[1500][1500];
int n,m;
long long Solve(int Sx,int Sy, long long counter)
{
    //cout<<counter<<" "<<Sx<<" "<<Sy<<" "<<visited[Sx][Sy]<<" "<<matrix[Sx][Sy]<<endl;
    if(visited[Sx][Sy]) return 0;
    if(Sx < 0 || Sx > m || Sy < 0 || Sy > n) return counter;
    visited[Sx][Sy] = true;
    if(matrix[Sx][Sy] == '>')
    {
        return Solve(Sx, Sy + 1, counter+1);
    }
    if(matrix[Sx][Sy] == '<')
    {
        return Solve(Sx, Sy - 1, counter+1);
    }
    if(matrix[Sx][Sy] == '^')
    {
        return Solve(Sx - 1, Sy, counter+1);
    }
    if(matrix[Sx][Sy] == 'v')
    {
        return Solve(Sx + 1, Sy, counter+1);
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    for(int i = 0 ; i < n; ++i)
    {
        string input;
        cin>>input;
        for(int j = 0; j < m; ++j)
        {
            matrix[i][j] = input[j];
        }
    }
    int q;
    cin>>q;
    for(int i = 0; i < q; ++i)
    {
        int Sx, Sy, Cx, Cy;
        char Cd;
        cin>>Sx>>Sy>>Cx>>Cy>>Cd;
        Sx--;
        Sy--;
        Cx--;
        Cy--;
        char temp = matrix[Cx][Cy];
        matrix[Cx][Cy] = Cd;
        cout<<Solve(Sx, Sy, 0)<<endl;
        matrix[Cx][Cy] = temp;
        for(int i = 0; i < n; ++i) for(int j = 0; j < m; ++j) visited[i][j] = false;
    }
    return 0;
}
