#include<iostream>
#include<cstdio>
using namespace std;

bool used[102][102];
int move[102][102];
int q,n,m;
int stx,sty;
int chx,chy;

void transform()
{
	char ch;
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			cin>>ch;
			if(ch == '>') move[i][j] = 3;
			else if(ch == '<') move[i][j] = 4;
			else if(ch == '^') move[i][j] = 1;
			else move[i][j] = 2;
		}
	}
}

void find_ans(int i, int j)
{
	int s = 0;
	bool flag = true;
	for(int e = 0; e < n; e++)
	{
		for(int l = 0; l <m; l++) used[e][l] = false;
	}
	while(flag == true)
	{
		used[i][j] = true; 
		s++;
		//printf("i=%d j=%d\n",i,j);
		if(move[i][j] == 1) 
		{
			i--;
		}
		else if(move[i][j] == 2)
		{
			i++;
		}
		else if(move[i][j]== 3)
		{
			j++;
		}
		else j--;
		if(j < 0 || j >= m || i < 0 || i >= n) flag = false;
		if(used[i][j] == true)
		{
			flag = false;
			s = 0;
		}
	}
	cout<<s<<endl;
}

int main()
{
	scanf("%d%d",&n,&m);
	transform();
	scanf("%d",&q);
	char c;
	int prev;
	for(int i = 0; i < q; i++)
	{
		scanf("%d%d%d%d",&stx,&sty,&chx,&chy);
		cin>>c;
		chx--;
		chy--;
		prev = move[chx][chy];
		if(c == '>') move[chx][chy] = 3;
		else if(c == '<') move[chx][chy] = 4;
		else if(c == '^') move[chx][chy] = 1;
		else move[chx][chy] = 2;
		find_ans(stx-1,sty-1);
		move[chx][chy] = prev;
	}
}
