#include <iostream>
using namespace std;

const int MAXN = 202;
const int MOD = 1000000007;

long long n, k;
int c[MAXN];

long long dp[MAXN][MAXN];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> c[i];
    }

    for (int i = 1; i <= k; ++ i)
    {
        if (c[1] == 0) dp[1][i] = 1;
        if (c[1] == i) dp[1][i] = 1;
    }
    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 1; j <= k; ++ j)
        {
            if (c[i] != 0 and c[i] != j) continue;
            for (int p = 1; p <= k; ++ p)
            {
                if (p != j) dp[i][j] = (dp[i][j] + dp[i - 1][p]) % MOD;
            }
        }
    }

    long long ans = 0;
    for (int i = 1; i <= k; ++ i)
    {
        ans = (ans + dp[n][i]) % MOD;
    }

    cout << ans << endl;
    return 0;
}
