#include <iostream>
using namespace std;

const int MAXN = 3003;
const int MOD = 1000000007;

long long n, k;
int c[MAXN];

long long dp[MAXN][MAXN];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> c[i];
    }

    for (int i = 1; i <= k; ++ i)
    {
        if (c[1] == 0) dp[1][i] = 1;
        if (c[1] == i) dp[1][i] = 1;
    }

    long long comm, diff, idx;
    if (c[1] == 0) {comm = 1; diff = idx = 0;}
    if (c[1] != 0) {comm = 0; diff = 1; idx = c[1];}

    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 1; j <= k; ++ j)
        {
            if (c[i] != 0 and c[i] != j) continue;

            if (j == idx)
            {
                dp[i][j] = (k - 1) * comm % MOD;
            }
            else
            {
                if (idx != 0) dp[i][j] = ((k - 2) * comm + diff) % MOD;
                else dp[i][j] = ((k - 1) * comm) % MOD;
            }
        }

        if (c[i] != 0)
        {
            comm = 0;
            diff = dp[i][c[i]];
            idx = c[i];
        }

        diff = dp[i][idx];
        if (idx == 1) comm = dp[i][2];
        else comm = dp[i][1];
    }

    long long ans = 0;
    for (int i = 1; i <= k; ++ i)
    {
        ans = (ans + dp[n][i]) % MOD;
    }

    /*for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= k; ++ j)
        {
            cout << dp[i][j] << ' ';
        }
        cout << endl << endl;
    }*/

    cout << ans << endl;
    return 0;
}
