#include <iostream>
using namespace std;

const int MAXN = 1503;

int n, m, q;
char a[MAXN][MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
        }
    }
}

bool vis[MAXN][MAXN];

int Answer(int x, int y)
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            vis[i][j] = 0;
        }
    }

    int cnt = 0;
    while (x >= 1 and x <= n and y >= 1 and y <= m)
    {
        vis[x][y] = 1;

        if (a[x][y] == '^') x--;
        else if (a[x][y] == '<') y--;
        else if (a[x][y] == '>') y++;
        else x++;
        if (vis[x][y] == 1) return 0;
        else cnt++;
    }

    return cnt++;;
}

int main()
{
    Init();

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int sx, sy, cx, cy;
        char cd, orig;
        cin >> sx >> sy >> cx >> cy >> cd;
        orig = a[cx][cy];
        a[cx][cy] = cd;
        cout << Answer(sx, sy) << endl;
        a[cx][cy] = orig;
    }
}
