#include<iostream>
using namespace std;

const int MOD = 1000000007;
const int MAXN = 500005;

int n, k, a[MAXN];

// start, finish, position, last
long long mem[MAXN][2];

int S, F;
long long solve(int p, bool l)
{
    int L=0;
    if(l) L=1;

    if(mem[p][L]) return mem[p][L];

    if(p==F-1)
    {
        if(l) // last is same as a[f]
        {
            return k-1;
        }
        else
        {
            return k-2;
        }
    }

    long long I=(solve(p+1, false)%MOD);
    long long II=(solve(p+1, true))%MOD;

    if(l) mem[p][L] = I*(k-1)%MOD;
    else mem[p][L] = (I*(k-2)%MOD+II)%MOD;

    return mem[p][L];
}

long long answ=1;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>k;
    for(int i=1; i<=n; ++i)
    {
        cin>>a[i];
    }

    a[0]=a[n+1]=k+1;

    S=0;

    for(int i=1; i<=n+1; ++i)
    {
        if(a[i]==0)
        {
            continue;
        }
        else
        {
            if(a[i-1]==0)
            {
                F=i;

                bool l=false;
                if(a[S]==a[F]) l=true;

                if(S==0 || F==n+1) answ=answ*solve(S+1, true)%MOD;
                else answ=answ*solve(S+1, l)%MOD;

                S=F;
            }
            else
            {
                S=i;
            }
        }
    }

    cout<<answ%MOD<<endl;

    return 0;
}
