#include<iostream>
#include<set>
using namespace std;

const int MAXN = 1502;

int n, m, q;
char a[MAXN][MAXN];

set< pair<int, int> > path;

int solve(int x, int y)
{
    int r=1;
    path.insert(make_pair(x, y));
    char d=a[x][y];

    while(true)
    {
        //cout<<x<<" "<<y<<" "<<d<<endl;
        if(d=='>')
        {
            y=y+1;
        }
        else if(d=='<')
        {
            y=y-1;
        }
        else if(d=='^')
        {
            x=x-1;
        }
        else // v
        {
            x=x+1;
        }

        if(x==(-1) || y==(-1) || x==m+1 || y==n+1)
            return r;

        r++;
        pair<int, int> c = make_pair(x, y);
        if(path.count(c)) return 0;
        path.insert(c);

        d=a[x][y];
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>m;

    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            char p;
            cin>>p;
            a[i][j]=p;
        }
    }

    cin>>q;

    int sx, sy, cx, cy;
    char cd;
    for(int i=0; i<q; ++i)
    {
        cin>>sx>>sy>>cx>>cy;
        cin>>cd;

        cx--; cy--;
        char prev=a[cx][cy];
        a[cx][cy]=cd;

        cout<<solve(sx-1, sy-1)<<endl;
        path.clear();

        a[cx][cy]=prev;
    }

    return 0;
}
