#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
using namespace std;

const long long REM = 1000000007;

long long A[500001], B[500001];
long long n, k;

long long CalcNoEnds(long long x)
{
    if (x == 0) return 1;
    long long ret = k;
    for (long long i=0; i<x-1; i++)
    {
        ret = ret*(k-1)%REM;
    }
    return ret;
}

long long CalcOneEnd(long long x)
{
    long long ret = 1;
    for (long long i=0; i<x; i++)
    {
        ret = ret*(k-1)%REM;
    }
    return ret;
}

long long CalcTwoDiffEnds(long long x)
{
    return A[x];
}

long long CalcTwoSameEnds(long long x)
{
    return ((k-1)*A[x-1])%REM;
}


int main ()
{
    cin>>n>>k;

    for (int i=0; i<=n; i++)
    {
        A[i] = -1;
        B[i] = -1;
    }

    A[0] = 1;
    A[1] = (k-2)%REM;

    for (int i=2; i<=n; i++)
    {
        A[i] = (((k-2)*A[i-1])%REM + ((k-1)*A[i-2])%REM)%REM;
    }

    int lastColPos = -1;
    int lastCol = -1;

    long long ans = 1;

    for (int i=0; i<n; i++)
    {
        int cur;
        scanf("%d", &cur);
        if (cur != 0)
        {
            if (lastColPos == -1)
            {
                ans = (ans*CalcOneEnd(i))%REM;
            }
            else
            {
                if (cur == lastCol)
                {
                    ans = (ans*CalcTwoSameEnds(i-lastColPos-1))%REM;
                }
                else
                {
                    ans = (ans*CalcTwoDiffEnds(i-lastColPos-1))%REM;
                }
            }
            lastCol = cur;
            lastColPos = i;
        }
    }

    if (lastColPos == -1)
    {
        ans = CalcNoEnds(n);
    }
    else
    {
        ans = ans*CalcOneEnd(n-lastColPos-1)%REM;
    }

    cout<<ans<<endl;
}
