#include<bits/stdc++.h>

using namespace std;

typedef pair<int, int> ii;

struct cell{
    long first;
    long second;
};



set<ii> cache;
char field[1500][1500];

int n,m;

ii shift(ii a, char instruction)
{
    switch (instruction)
    {
        case 'v':
            return ii(a.first+1,a.second  );
        case '^':
            return ii(a.first-1,a.second  );
        case '>':
            return ii(a.first  ,a.second+1);
        case '<':
            return ii(a.first  ,a.second-1);
        default:
            return a;
    }
}

long solve(ii start)
{
    ii curr = start;
    long result = 0;
    while(curr.first>=0  &&
          curr.second>=0  &&
          curr.first<n  &&
          curr.second<m)
    {
        if(cache.find(curr) != cache.end())
            return 0;

        cache.insert(curr);
        curr = shift(curr, field[curr.first][curr.second]);
        //cout<<curr.first<<":"<<curr.second<<"  ";
        result ++;
    }
    return result;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;

    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
            cin>>field[i][j];

    int q;
    ii s, c(0,0);
    char cmd, arch;

    cin >> q;
    for(int _=0;_<q;_++)
    {
        cin>>s.first>>s.second>>c.first>>c.second>>cmd;

        //Normalize
        c.first--;c.second--;s.first--;s.second--;

        //Pesho
        arch = field[c.first][c.second];
        field[c.first][c.second] = cmd;

        cout<<solve(s)<<endl;


        //Reset for next
        field[c.first][c.second] = arch;
        cache.clear();
    }


    return 0;
}

/*
3 4
>>v>
><v>
^>>^
4
2 1 1 1 ^
2 1 2 2 >
2 1 2 1 <
1 1 2 4 ^

*/
