#include <iostream>
using namespace std;
typedef unsigned long long int i;

const i m = 1000000007;

i powmod(i a, i b, i m) {
    i res = 1;
    while (b) {
        if (b & 1) {
            res = (res * a) % m;
        }
        a = (a * a) % m;
        b >>= 1;
    }
    return res;
}

i solve(i k, i first, i len, i last) {
    if (last == 0 && first == 0) {
        return (k*powmod(k-1, len-1, m))%m;
    }
    if (last == 0 || first == 0) {
        return powmod(k-1, len, m);
    }
    // neither last and first are 0 now


    i res = first != last;
    i kk = 1;
    for (i j=0; j<len; j++) {
        kk = (kk*(k-1)) % m;
        res = (kk-res) % m;
    }

    return res;
}

int main() {
    i n, k;
    cin >> n >> k;
    i res = 1;
    i first=0;
    i last=0;
    i uncolored=0;
    for (i j=0; j<n; j++) {
        i stone;
        cin >> stone;
        if (stone == 0) {
            uncolored++;
            continue;
        } else {
            last = stone;
            res = (res * solve(k, first, uncolored, last)) % m;
            uncolored = 0;
            first = last;
            last = 0;
            continue;
        }
    }
    res = (res * solve(k, first, uncolored, last)) % m;
    cout << (res % m);
}

