#include <iostream>
using namespace std;
typedef unsigned long long int i;

const i m = 19;// 1000000007; // tested with 19

// 3rd example test without modulo: 1104402369930
//10 103
// 0 1 0 0 0 9 0 0 5 7

i powmod(i a, i b, i m) {
    i res = 1;
    a = a % m;
    while (b) {
        if (b & 1) {
            res = (res * a) % m;
        }
        a = (a * a) % m;
        b >>= 1;
    }
    return res;
}

i solve(i k, i first, i len, i last) {
    if (last == 0 && first == 0) {
        // len is never 0
        return (k*powmod(k-1, len-1, m)) % m;
    }
    if (last == 0 || first == 0) {
        return powmod(k-1, len, m);
    }
    // neither last and first are 0 now


    i res = first != last ? 1 : 0;
    i kk = 1;
    for (i j=0; j<len; j++) {
        kk = (kk*(k-1));// % m;
        res = (kk-res) % m;
    }

    return res % m;
}

int main() {
    i n, k;
    cin >> n >> k;
    i res = 1;
    i first=0;
    i last=0;
    i uncolored=0;
    for (i j=0; j<n; j++) {
        i stone;
        cin >> stone;
        if (stone == 0) {
            uncolored++;
            continue;
        } else {
            last = stone;
            res = (res * solve(k, first, uncolored, last)) % m;
            uncolored = 0;
            first = last;
            last = 0;
            continue;
        }
    }
    res = (res * solve(k, first, uncolored, last)) % m;
    cout << (res % m);
    return 0;
}

