#include <iostream>
using namespace std;
typedef long long int i;

void walk(char dir, i* x, i* y) {
    //cout << *x << *y << endl;
    switch (dir) {
    case '>':
        *y += 1;
        break;
    case '<':
        *y -= 1;
        break;
    case '^':
        *x -= 1;
        break;
    case 'v':
        *x += 1;
        break;
    }
}

int main() {
    i n,m;
    cin >> n >> m;
    char maze[n][m];
    for (i nn=0; nn<n; nn++) {
        for (i mm=0; mm<m; mm++) {
            cin >> maze[nn][mm];
        }
    }
    i q;
    cin >> q;
    for (i qq=0; qq<q; qq++) {
        i sx, sy;
        i cx, cy;
        char cd;
        char saved;
        i fx, fy;
        cin >> sx >> sy >> cx >> cy >> cd;
        sx--;
        sy--;
        cx--;
        cy--;
        saved = maze[cx][cy];

        maze[cx][cy] = cd;
        /*for (i nn=0; nn<n; nn++) {
            for (i mm=0; mm<m; mm++) {
                cout<< maze[nn][mm];
            }
            cout << endl;
        }*/

        fx = sx;
        fy = sy;
        i res = 0;
        i steps = 0;
        do {
            walk(maze[fx][fy],&fx,&fy);
            steps++;
            if (fx < 0 || fx >= n || fy < 0 || fy >= m) {
                res = steps;
                break;
            }
            walk(maze[fx][fy],&fx,&fy);
            steps++;
            if (fx < 0 || fx >= n || fy < 0 || fy >= m) {
                res = steps;
                break;
            }
            walk(maze[sx][sy],&sx,&sy);
        } while (fx != sx || fy != sy);
        cout << res << endl;
        maze[cx][cy]=saved;
    }
}
