#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
long long m;
pair <long long, long long> people [300005];
vector <long long> moments;
int ans = 0;
int cnt [300005];

int tree [2000006];
void upd (int l, int r, int pos, int x){
    if (l == r){
        tree [pos] ++;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) upd (l, mid, pos << 1, x);
    else upd (mid + 1, r, pos << 1 | 1, x);
    tree [pos] = tree [pos << 1] + tree [pos << 1 | 1];
}
int query (int l, int r, int pos, int ql, int qr){
    if (ql <= l && r <= qr) return tree [pos];
    if (r < ql || qr < l) return 0;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, pos << 1 | 1, ql, qr);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m;
    for (int i = 1; i <= n; i ++){
        cin >> people [i].first >> people [i].second;
        moments.push_back (people [i].first);
        moments.push_back (people [i].second);
    }
    sort (moments.begin (), moments.end ());
    sort (people + 1, people + n + 1);
    int N = moments.size ();

    for (int i = 1; i <= n; i ++){
        int pos = lower_bound (moments.begin (), moments.end (), people [i].second) - moments.begin ();
        upd (0, N - 1, 1, pos);
        pos = lower_bound (moments.begin (), moments.end (), people [i].first + m) - moments.begin ();
        cnt [i] = query (0, N - 1, 1, pos, N - 1);
        pos = lower_bound (people + 1, people + n + 1, make_pair (people [i].first - m + 1, 0ll)) - people - 1;
        ans = max (ans, cnt [i] + cnt [pos]);
        cnt [i] = max (cnt [i], cnt [i - 1]);
    }
    cout << ans << '\n';

}
