#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
long long m;
pair <long long, long long> people [300005], people1 [300005];
vector <long long> moments;
vector <pair <long long, int> > moments1;
pair <int, int> Pos [300005];
int ans = 0;
int cnt [300005];
int N;

int fenwick [600005];
void upd (int x){
    x ++;
    while (x <= N){
        fenwick [x] ++;
        x += x & -x;
    }
}
int query (int x){
    x ++;
    int q = 0;
    while (x > 0){
        q += fenwick [x];
        x -= x & -x;
    }
    return q;
}

bool comp (pair <long long, long long> p1, pair <long long, long long> p2){
    return p1.second < p2.second;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);
    cout.tie (0);

    cin >> n >> m;
    for (int i = 1; i <= n; i ++){
        cin >> people [i].first >> people [i].second;
        people1 [i] = people [i];
        moments.push_back (people [i].first);
        moments.push_back (people [i].second);
    }
    sort (moments.begin (), moments.end ());
    sort (people + 1, people + n + 1);
    sort (people1 + 1, people1 + n + 1, comp);
    for (int i = 1; i <= n; i ++){
        moments1.push_back ({people [i].second, i});
        moments1.push_back ({people1 [i].first, n + i});
    }
    sort (moments1.begin (), moments1.end ());
    for (int i = 0; i < N; i ++){
        if (moments1 [i].second <= n) Pos [moments1 [i].second].first = i;
        else Pos [moments1 [i].second - n].second = i;
    }
    N = moments.size ();

    int pos1 = 0;
    for (int i = 1; i <= n; i ++){
        //int pos = lower_bound (moments.begin (), moments.end (), people [i].second) - moments.begin ();
        upd (Pos [i].first);
        while (pos1 < N && moments [pos1] < people [i].first + m) pos1 ++;
        //pos = lower_bound (moments.begin (), moments.end (), people [i].first + m) - moments.begin ();
        cnt [i] = i - query (pos1 - 1);
        cnt [i] = max (cnt [i], cnt [i - 1]);
    }
    for (int i = 1; i < 600005; i ++) fenwick [i] = 0;
    pos1 = N - 1;
    for (int i = n; i >= 1; i --){
        //int pos = lower_bound (moments.begin (), moments.end (), people1 [i].first) - moments.begin ();
        upd (Pos [i].second);
        while (pos1 >= 0 && moments [pos1] > people1 [i].second - m) pos1 --;
        //pos = upper_bound (moments.begin (), moments.end (), people1 [i].second - m) - moments.begin () - 1;
        int x = query (pos1);
        int pos = lower_bound (people + 1, people + n + 1, make_pair (people1 [i].second - 2*m + 1, 0ll)) - people - 1;
        ans = max (ans, x + cnt [pos]);
    }
    cout << ans << '\n';

}
