#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

///hansha da se pruska, do dolu da se spuska
///v zemqta da se bluska, seksi stori puska
///snima si narochno tqloto porochno
///za tiq deto suskat, da hodqt da go luskat
///hansha da se pruska, do dolu da se spuska
///v zemqta da se bluska, net tursi veche vruzka
///vikai siva guska na taq pesen mrusna
///pochvam da jiveq usilvai mi djq

const int maxn = 1503;

int n, m, q;
char a[maxn][maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        cin >> a[i][j];

    cin >> q;
}

pair <int, int> nxt[maxn][maxn];
vector <vector <pair <int, int> > > cycles;
int cycle_idx[maxn][maxn], cycle_pos[maxn][maxn];
int distance_in_cycle(pair <int, int> x, pair <int, int> y)
{
    int pos1 = cycle_pos[x.first][x.second], pos2 = cycle_pos[y.first][y.second];
    if (pos2 >= pos1)
        return pos2 - pos1 + 1;

    else
        return pos2 + (int)cycles[cycle_idx[x.first][x.second]-1].size() - pos1 + 1;
}

int used[maxn][maxn];
void precompute()
{
    for (int i = 1; i <= n; i++)
    for (int j = 1; j <= m; j++)
    {
        int x = i, y = j;
        if (a[i][j] == '^')
            x--;

        else
            if (a[i][j] == '>')
            y++;

        else
            if (a[i][j] == '<')
            y--;

        else
            x++;

        if (x < 1 || x > n || y < 1 || y > m)
        x = y = 0;

        nxt[i][j] = {x, y};
    }

    int curr_used_idx = 0;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        if (!used[i][j])
        {
            curr_used_idx++;
            stack <pair <int, int> > st;
            int x = i, y = j;
            while (!used[x][y] && make_pair(x, y) != make_pair(0, 0))
            {
                used[x][y] = curr_used_idx;
                st.push({x, y});

                auto temp = nxt[x][y];
                if (used[temp.first][temp.second])
                {
                    if (used[temp.first][temp.second] != used[i][j])
                        break;

                    vector <pair <int, int> > cycle;
                    while (!st.empty() && st.top() != temp)
                    {
                        cycle.push_back(st.top());
                        st.pop();
                    }

                    cycle.push_back(st.top());
                    reverse(cycle.begin(), cycle.end());

                    cycles.push_back(cycle);
                    break;
                }

                x = temp.first, y = temp.second;
            }
        }

    for (int i = 0; i < (int)cycles.size(); i++)
    for (int j = 0; j < (int)cycles[i].size(); j++)
        {
            cycle_idx[cycles[i][j].first][cycles[i][j].second] = i + 1;
            cycle_pos[cycles[i][j].first][cycles[i][j].second] = j + 1;
        }
}

int deg[maxn][maxn];
vector <pair <pair <int, int>, pair <int, int> > > adj[maxn][maxn];
int depth[maxn][maxn];
int dfs_time;
int tin[maxn][maxn], tout[maxn][maxn];
void dfs(pair <int, int> x)
{
    tin[x.first][x.second] = ++dfs_time;
    for (auto i: adj[x.first][x.second])
    {
        depth[i.first.first][i.first.second] = depth[x.first][x.second] + 1;
        dfs(i.first);
    }

    tout[x.first][x.second] = ++dfs_time;
}

bool is_upper(pair <int, int> x, pair <int, int> y)
{
    return tin[x.first][x.second] <= tin[y.first][y.second] && tout[x.first][x.second] >= tout[y.first][y.second];
}

int distance(pair <int, int> x, pair <int, int> y)
{
    if (cycle_idx[x.first][x.second] && cycle_idx[y.first][y.second])
    {
        if (cycle_idx[x.first][x.second] != cycle_idx[y.first][y.second])
            return -1;

        return distance_in_cycle(x, y);
    }

    if (cycle_idx[x.first][x.second] && !cycle_idx[y.first][y.second])
        return -1;

    if (!cycle_idx[x.first][x.second] && !cycle_idx[y.first][y.second])
    {
        if (!is_upper(y, x))
            return -1;

        int ans = depth[x.first][x.second] - depth[y.first][y.second];
        if (y != make_pair(0, 0))
        ans++;

        return ans;
    }

    auto el = cycles[cycle_idx[y.first][y.second]-1][0];
    if (!is_upper(el, x))
        return -1;

    int ans = depth[x.first][x.second] - depth[el.first][el.second];
    for (auto i: adj[el.first][el.second])
        if (is_upper(i.first, x))
        ans += distance_in_cycle(i.second, y);

    return ans;
}

void solve()
{
    precompute();
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        {
            auto curr = nxt[i][j];
            if (curr == make_pair(0, 0))
            {
                adj[0][0].push_back({{i, j}, {-1, -1}});
                deg[i][j]++;
            }

            else
            {
                if (cycle_idx[curr.first][curr.second] && cycle_idx[i][j])
                    continue;

                if (!cycle_idx[curr.first][curr.second])
                {
                    adj[curr.first][curr.second].push_back({{i, j}, {-1, -1}});
                    deg[i][j]++;
                }

                else
                {
                    auto el = cycles[cycle_idx[curr.first][curr.second]-1][0];
                    adj[el.first][el.second].push_back({{i, j}, {curr.first, curr.second}});
                    deg[i][j]++;
                }
            }
        }

    depth[0][0] = 1;
    dfs({0, 0});
    for (int i = 1; i <= n; i++)
    for (int j = 1; j <= m; j++)
    if (!deg[i][j])
    {
        depth[i][j] = 1;
        dfs({i, j});
    }

    while (q--)
    {
        int sx, sy, cx, cy;
        char dir;

        cin >> sx >> sy >> cx >> cy >> dir;

        int x = cx, y = cy;
        if (dir == '^')
            x--;

        else
            if (dir == '>')
            y++;

        else
            if (dir == '<')
            y--;

        else
            x++;

        if (x < 1 || x > n || y < 1 || y > m)
        x = y = 0;

        int d1 = distance({sx, sy}, {cx, cy});
        if (d1 == -1)
        {
            int d2 = distance({sx, sy}, {0, 0});
            if (d2 == -1)
                cout << 0 << endl;

            else
                cout << d2 << endl;
        }

        else
        {
            if (x == 0 && y == 0)
            cout << d1 << endl;

            else
            {
                if (distance({x, y}, {cx, cy}) != -1)
                    cout << 0 << endl;

                else
                {
                    int d2 = distance({x, y}, {0, 0});
                    if (d2 == -1)
                        cout << 0 << endl;

                    else
                    cout << d1 + d2 << endl;
                }
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
3 4
>>v>
><v>
^>>^
1
2 1 1 1 ^
2 1 2 2 >
2 1 2 1 <
1 1 2 4 ^

*/
