#include<bits/stdc++.h>
#define ull unsigned long long
#pragma optimize GCC Ofast
using namespace std;

/// twitch.tv/bili220022

int n,u,v, m;
vector<pair<int,int>> people;

int measure(int k1, int k2) {
    if(k1 + m > k2) {
        return 0;
    }
    int res = 0;
    for(auto p : people) {
        if(p.first <= k1 and p.second >= k1 + m) {
            res++;
        }
        if(p.first <= k2 and p.second >= k2 + m) {
            res++;
        }
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    cin>>m;
    set<int> timesToStart;
    timesToStart.insert(0);
    for(int i = 0 ; i < n ; i++) {
        cin>>u>>v;
        if(v-u > m) {
            people.push_back({u,v});
            timesToStart.insert(u);
        }
    }
    int res = 0;
    for(int k1 : timesToStart) {
        for(int k2 : timesToStart) {
            if(k1 > k2) {
                continue;
            }
            res = max(res, measure(k1, k2));
            res = max(res, measure(k1, k1 + m));
        }
    }
    cout<<res<<endl;
    return 0;
}
