#include<iostream>
using namespace std;
char tab[2000][2000];
int dist[4000000];
int nxt[4000000];
bool visited[4000000];
bool cycle[4000000];
int calci(int x,int y){
    return y*2000+x;
}
int lifting[4000000][30];
int n,m;
void dfs(int x,int y){
    int i=calci(x,y);
    visited[i]=1;
    int x1=x,y1=y;
    switch(tab[x][y]){
    case '<':
        x1--;
        break;
    case '>':
        x1++;
        break;
    case '^':
        y1--;
        break;
    case 'v':
        y1++;
        break;
    }
    if(x1<0 || x1>=m || y1<0 || y1>=n){
        nxt[i]=-1;
        dist[i]=1;
        return;
    }
    int i1=calci(x1,y1);
    if(visited[i1] && dist[i1]==0){
        cycle[i]=1;
        nxt[i]=-1;
        dist[i]=1;
        return;
    }
    if(!visited[i1]){
        dfs(x1,y1);
    }
    nxt[i]=i1;
    cycle[i]=cycle[i1];
    dist[i]=dist[i1]+1;
}
int main(){
    int q;
    cin>>n>>m;
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            cin>>tab[x][y];
        }
    }
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            int i=calci(x,y);
            if(!visited[i]){
                dfs(x,y);
            }
        }
    }
    for(int y=0;y<n;y++){
        for(int x=0;x<m;x++){
            int i=calci(x,y);
            if(cycle[i]){
                cout<<0;
            }else{
                cout<<dist[i];
            }
            cout<<" ";
        }
        cout<<endl;
    }
    return 0;
}
