#include<iostream>
using namespace std;
char tab[2000][2000];
int dist[4000000];
int nxt[4000000];
bool visited[4000000];
bool cycle[4000000];
int calci(int x,int y)
{
    return y*2000+x;
}
int lifting[4000000][30];
int n,m;
void dfs(int x,int y)
{
    int i=calci(x,y);
    visited[i]=1;
    int x1=x,y1=y;
    switch(tab[x][y])
    {
    case '<':
        x1--;
        break;
    case '>':
        x1++;
        break;
    case '^':
        y1--;
        break;
    case 'v':
        y1++;
        break;
    }
    if(x1<0 || x1>=m || y1<0 || y1>=n)
    {
        nxt[i]=-1;
        dist[i]=1;
        return;
    }
    int i1=calci(x1,y1);
    if(visited[i1] && dist[i1]==0)
    {
        cycle[i]=1;
        nxt[i]=-1;
        dist[i]=1;
        return;
    }
    if(!visited[i1])
    {
        dfs(x1,y1);
    }
    nxt[i]=i1;
    cycle[i]=cycle[i1];
    dist[i]=dist[i1]+1;
}
int lift(int i,int h)
{
    for(int j=30; j>=0; j--)
    {
        if((1<<j)<=h)
        {
            h-=(1<<j);
            i=lifting[i][j];
        }
    }
    return i;
}
int main()
{
    int q;
    cin>>n>>m;
    for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            cin>>tab[x][y];
        }
    }
    for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            int i=calci(x,y);
            if(!visited[i])
            {
                dfs(x,y);
            }
        }
    }
    /*for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            int i=calci(x,y);
            if(cycle[i])
            {
                cout<<0;
            }
            else
            {
                cout<<dist[i];
            }
            cout<<" ";
        }
        cout<<endl;
    }*/
    for(int y=0; y<n; y++)
    {
        for(int x=0; x<m; x++)
        {
            int i=calci(x,y);
            lifting[i][0]=nxt[i];
        }
    }
    for(int j=1; j<30; j++)
    {
        for(int y=0; y<n; y++)
        {
            for(int x=0; x<m; x++)
            {
                int i=calci(x,y);
                if(lifting[i][j-1]!=-1)
                {
                    lifting[i][j]=lifting[lifting[i][j-1]][j-1];
                }
                else
                {
                    lifting[i][j]=-1;
                }
            }
        }
    }
    /*for(int j=0; j<3; j++)
    {
        for(int y=0; y<n; y++)
        {
            for(int x=0; x<m; x++)
            {
                int i=calci(x,y);
                cout<<lifting[i][j]<<" ";
            }
            cout<<endl;
        }
        cout<<endl;
    }*/
    cin>>q;
    for(int i=0; i<q; i++)
    {
        int sx,sy,x,y;
        char sign;
        cin>>sy>>sx>>y>>x>>sign;
        sy--;
        sx--;
        y--;
        x--;
        int si=calci(sx,sy),ci=calci(x,y);
        int diff=dist[si]-dist[ci];
        int anc=-1;
        if(diff>=0)
        {
            anc=lift(si,diff);
        }
        if(diff<0 || anc!=ci)
        {
            if(cycle[si])
            {
                cout<<0;
            }
            else
            {
                cout<<dist[si];
            }
            cout<<endl;
        }
        else
        {
            //int dist=diff;
            int x1=x,y1=y;
            switch(sign)
            {
            case '<':
                x1--;
                break;
            case '>':
                x1++;
                break;
            case '^':
                y1--;
                break;
            case 'v':
                y1++;
                break;
            }
            if(x1<0 || x1>=m || y1<0 || y1>=n)
            {
                cout<<diff+1<<endl;
                continue;
            }
            int i1=calci(x1,y1);
            int diff1=dist[i1]-dist[i];
            int anc1=-1;
            if(diff1>=0)
            {
                anc1=lift(i1,diff1);
            }

            if(diff>=0 && anc1==i)
            {
                cout<<0<<endl;
            }
            else
            {
                cout<<diff+1+dist[i1]<<endl;
            }
        }
    }
    return 0;
}
