#include <iostream>

using namespace std;

const int maxx = 1500;
char cell[maxx][maxx];
bool used[maxx][maxx];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m;
    cin >> n >> m;

    for(int i=1; i<=n; i++){
        for(int j=1; j<=m; j++){
            cin >> cell[i][j];
        }
    }

    int q;
    cin >> q;

    for(int i=0; i<q; i++){
        int x, y;
        cin >> x >> y;

        int a, b;
        cin >> a >> b;
        char note = cell[a][b];

        cin >> cell[a][b];

        for(int I=1; I<=n; I++){
            for(int J=1; J<=m; J++){
                used[I][J] = 0;
            }
        }

        long long countt = 0;

        bool inCycle = false;
        bool escaped = false;

        while(true){

            if(used[x][y]){
                inCycle = 1;
                break;
            }
            used[x][y] = 1;

            if(cell[x][y] == '>'){
                y++;
            }
            else if(cell[x][y] == '<'){
                y--;
            }
            else if(cell[x][y] == 'v'){
                x++;
            }
            else if(cell[x][y] == '^'){
                x--;
            }

            countt++;

            if(x>=1 && x<=n && y>=1 && y<=m){
                escaped = 1;
                break;
            }
        }

        if(escaped) cout << countt << endl;
        if(inCycle) cout << 0 << endl;

        cell[a][b] = note;
    }

    return 0;
}
