#include <iostream>
#include <cstring>

using namespace std;

const int MAXN = 1e6 + 5;
const long long mod = 1e9 + 7;

int n;
long long k;
int a[MAXN];

int nxtVal[MAXN];
long long memo[MAXN][2];

void init()
{
    int val = -1;
    for(int i = n-1;i>=0;i--)
    {
        nxtVal[i] = val;
        if(a[i]!=0) val = a[i];
    }
}

long long rec(int ind, int isEqual)
{
    if(ind==n) return 1;
    if(memo[ind][isEqual]!=-1)
        return memo[ind][isEqual];

    long long ans = 0;
    if(a[ind]==0)
    {
        if(a[ind+1]==0)
        {
            if(ind==0)
            {
                if(nxtVal[ind]!=-1)
                {
                    //false
                    ans += ((k-1)*rec(ind+1, false))%mod;

                    //true
                    ans += (1*rec(ind+1, true))%mod;
                }
                else
                {
                    //false
                    ans += (k*rec(ind+1, false))%mod;

                    //true
                    ans += 0;
                }
            }
            else
            {
                if(isEqual==false)
                {
                    if(nxtVal[ind]!=-1)
                    {
                        //false
                        ans += ((k-2)*rec(ind+1, false))%mod;

                        //true
                        ans += (1*rec(ind+1, true))%mod;
                    }
                    else
                    {
                        //false
                        ans += ((k-1)*rec(ind+1, false))%mod;

                        //true
                        ans += 0;
                    }
                }
                else
                {
                    //false
                    ans += ((k-1)*rec(ind+1, false))%mod;

                    //true
                    ans += 0;
                }
            }
        }
        else
        {
            if(ind!=0)
            {
                if(isEqual==false)
                {
                    //false
                    ans += ((k-2)*rec(ind+1, false))%mod;

                    //true
                    ans += 0;
                }
                else
                {
                    //false
                    ans += ((k-1)*rec(ind+1, false))%mod;

                    //true
                    ans += 0;
                }
            }
            else
            {
                //false
                ans += ((k-1)*rec(ind+1, false))%mod;

                //true
                ans += 0;
            }
        }
    }
    else
    {
        ans += (1*rec(ind+1, (nxtVal[ind]==a[ind])))%mod;
    }

    ans %= mod;
    memo[ind][isEqual] = ans;

    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> a[i];
    init();

    memset(memo, -1, sizeof(memo));
    cout << rec(0, false) << '\n';
}
