#include<bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int x, y;
    edge() { }
    edge(int x, int y) :x(x), y(y) { }
    bool operator< (const edge &o) const
    {
        if(x==o.x) return y<o.y;
        return x<o.x;
    }
};

struct point
{
    int x, t;
    point() { }
    point(int x, int t) :x(x), t(t) { }
    bool operator<(const point &o) const
    {
        return x<o.x;
    }
};

const int nmax=300010;
edge a[nmax];
vector<edge> v;
vector<point> p;

int main()
{
	ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, m, ans=0, sum, sum2;
    cin>>n>>m;
    for(int i=0; i<n; ++i) cin>>a[i].x>>a[i].y;
    sort(a, a+n);
    if(m==1)
    {
        for(int i=0; i<n; ++i)
        {
            p.push_back({a[i].x, 1});
            p.push_back({a[i].y, 0});
        }
        sort(p.begin(), p.end());
        int m1=0, m2=0, cnt=0, last=0;
        for(int i=0; i<(int)p.size(); ++i)
        {
            if(last!=p[i].x)
            {
                if(cnt>m1) m2=m1, m1=cnt;
                else if(cnt>m2) m2=cnt;
            }
            if(p[i].t==1) cnt++;
            else cnt--;

            last=p[i].x;
        }
        cout<<m1+m2<<endl;
        return 0;
    }
    for(int i=0; i<n; ++i)
    {
        sum=0;
        edge s(a[i].x, a[i].x+m);
        for(int j=0; j<n; ++j)
        {
            if(a[j].x<=s.x&&a[j].y>=s.y) sum++;
        }
        v.push_back({a[i].x, sum});
        s={a[i].x+m, a[i].x+m+m};
        sum2=0;
        for(int j=0; j<n; ++j)
        {
            if(a[j].x<=s.x&&a[j].y>=s.y) sum2++;
        }
        ans=max(ans, sum+sum2);
    }
    for(int i=0; i<n; ++i)
    {
        for(int j=i+1; j<n; ++j)
        {
            if(v[i].x+m<=v[j].x||v[j].x+m<=v[i].x) ans=max(ans, v[i].y+v[j].y);
        }
    }
    cout<<ans<< endl;
	return 0;
}
