#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxn=1e6+5;
vector<pair<int,int> >v;
vector<long long int>sequence;
long long int n,m,a[3*maxn];
long long int ans=0,idx=0;
priority_queue<long long int>q;
priority_queue<pair<long long int,long long int> >s;
///----------------------------------------------
void read()
{
    pair<long long, long long> p;
    cin>>n>>m;
    for(int i=0;i<n;i++)
    {
        cin>>p.first>>p.second;
        v.push_back(p);
    }
}
///----------------------------------------------
void fill_sequence()
{
    for(int i=0;i<n;i++)
    {
        sequence.push_back(v[i].first);
        sequence.push_back(v[i].first+m);
        if(v[i].first>0)
        {
            sequence.push_back(v[i].first-m);
        }
    }
}
///----------------------------------------------
void find_first_interval()
{
    for(int i=0;i<sequence.size();i++)
    {
        if(sequence[i]<0)continue;
        while(idx<=n-1 && v[idx].first<=sequence[i])
        {
            q.push(-v[idx].second);
            idx++;
        }
        while(!q.empty() && -q.top()<sequence[i]+m){q.pop();}
        a[i]=q.size();
    }
}
///----------------------------------------------
void init_queue()
{
    for(int i=0;i<sequence.size();i++)
    {
        s.push(make_pair(a[i],sequence[i]));
    }
}
///----------------------------------------------
void solve()
{
    sort(v.begin(), v.end());
    fill_sequence();
    sort(sequence.begin(),sequence.end());
    find_first_interval();
    init_queue();
    for(int i=0;i<sequence.size();i++)
    {
        while(!s.empty() && s.top().second<sequence[i]+m)
        {
            s.pop();
        }
        if(!s.empty())
        {
            ans=max(ans, a[i]+s.top().first);
        }
    }
    cout<<ans<< endl;
}
///----------------------------------------------
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
