#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const maxn = 1501;
int const inf = (1<<31)-1;

int to[maxn*maxn];
char o[maxn*maxn];
int n,m;
vector<int>root;
vector<int>v[maxn*maxn];
bool used[maxn*maxn];
int idx[maxn*maxn],pos[maxn*maxn],id;

map<int,vector<pair<int,int> > >lvl;
void LCA(int i, int par,int level)
{
    if(!pos[i])
        pos[i] = lvl[id].size()+1;
    lvl[id].push_back({level,i});
    idx[i] = id;
    int j,sz = v[i].size();
    for(j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(nb == par) continue;
        {
            LCA(nb,i,level+1);
            lvl[id].push_back({level,i});
        }
    }
}

struct SG_tree
{
    vector<pair<int,int> >tree;
    int n;

    SG_tree(){}
    SG_tree(int _n)
    {
        n = _n;
        tree.resize(4*n);
    }

    void real_make(int k, int l, int r)
    {
        if(l == r)
        {
            tree[k] = lvl[id][l-1];

            return;
        }

        real_make(k*2,l,(l+r)/2);
        real_make(k*2+1,(l+r)/2+1,r);

        if(tree[k*2].first < tree[k*2+1].first)
            tree[k] = tree[k*2];
        else tree[k] = tree[k*2+1];
    }

    void make_tree()
    {
        real_make(1,1,n);
    }

    pair<int,int> real_ans(int k,int l,int r,int x,int y)
    {
        if(x <= l && y >= r)
            return tree[k];
        if(x > r || y < l)
            return make_pair(inf,0);

        int mid = (l+r)/2;

        pair<int,int> pl = real_ans(k*2,l,mid,x,y);
        pair<int,int> pr = real_ans(k*2+1,mid+1,r,x,y);

        if(pl.first < pr.first)
            return pl;
        else return pr;

    }

    int get_lca(int a,int b)
    {
        if(pos[a] > pos[b])swap(a,b);
        return real_ans(1,1,n,pos[a],pos[b]).second;
    }
};

vector<SG_tree>tree;
void hardcore_()
{
    int i;
    for(i=1; i<=n*m; i++)
    {
        if(to[i] == 0)
            root.push_back(i);

        v[i].push_back(to[i]);
        v[to[i]].push_back(i);
    }

    int sz = root.size();
    for(i=0;i<sz;i++)
    {
        id = i;
        LCA(root[id],0,1);

        tree.push_back(SG_tree(lvl[id].size()));
        tree[id].make_tree();
    }

}

void change_pos(int i, int j, char c)
{
    if(c == '^')
    {
        if(i == 0)
            to[i*m+j] = 0;
        else to[i*m+j] = (i-1)*m+j;
    }
    else if(c == '>')
    {
        if(j == m)
            to[i*m+j] = 0;
        else to[i*m+j] = i*m+j+1;
    }
    else if(c == '<')
    {
        if(j == 1)
            to[i*m+j] = 0;
        else to[i*m+j] = i*m+j-1;
    }
    else
    {
        if(i == n-1)
            to[i*m+j] = 0;
        else to[i*m+j] = (i+1)*m+j;
    }
}

void read()
{
    int i,j;
    char c;

    cin>>n>>m;

    for(i=0; i<n; i++)
        for(j=1;j<=m;j++)
    {
        cin>>c;
        o[i*m+j] = c;

        change_pos(i,j,c);
    }
}
int ans;
bool solve(int i)
{
    if(i == 0)
        return true;
    ans ++;
    used[i] = true;
    if(used[to[i]])
        return false;
    return solve(to[i]);
}

int dist[maxn*maxn],md[maxn*maxn];
int d;
int dfs(int i,int D)
{
    used[i] = true;
    idx[i] = id;
    if(!used[to[i]])
    {
        D = dfs(to[i],D+1);
        d++;
        dist[i] = d;
    }

    md[i] = D;
    return D;
}

int dfs2(int i)
{
    if(i == 0)
        return 0;

    used[i] = true;
    if(!used[to[i]])
        return dfs2(to[i]);
    else return 1;
}
bool check()
{
    int i;
    for(i=1;i<=n*m;i++)
    {
        if(!used[i])
            if(dfs2(i))
                return false;
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q,i;

    read();

    int Sx,Sy,x,y;
    char c;

    cin>>q;

    if(q <= 1000)
    for(i=0;i<q;i++)
    {
        cin>>Sx>>Sy>>x>>y>>c;
        x--;
        Sx--;

        ans = 0; memset(used,0,sizeof(used));
        change_pos(x,y,c);
        if(solve(Sx*m+Sy))
        {
            cout<<ans<<endl;
        }
        else cout<<0<<endl;
        change_pos(x,y,o[x*m+y]);
    }
    else if(check())
    {
        memset(used,0,sizeof(used));
        for(i=1; i<=n*m; i++)
            if(!used[i])
        {
            id++; d = 0;
            dfs(i,1);
        }

        for(i=0;i<q;i++)
        {
            cin>>Sx>>Sy>>x>>y>>c;
            x--;
            Sx--;

            change_pos(x,y,c);
            //cout<<to[x*m+y]<< " "<<idx[x*m+y]<<" "<<idx[Sx*m*Sy]<<endl;
            if(to[x*m+y] || idx[x*m+y] != idx[Sx*m+Sy])
                cout<<0<<endl;
            else
            {
                int S,E;
                S = Sx*m+Sy;
                E = x*m+y;

                if(dist[S] >= dist[E])
                    cout<<dist[S] - dist[E] +1<<endl;
                else
                    cout<<md[S] - dist[E] + dist[S] +1<<endl;
            }

            change_pos(x,y,o[x*m+y]);
        }
    }

    else
    {
        memset(used,0,sizeof(used));
        hardcore_();

        for(i=0;i<q;i++)
        {
            cin>>Sx>>Sy>>x>>y>>c;
            Sx -- ;
            x--;

            int S = Sx*m+Sy;
            int E = x*m + y;

            change_pos(x,y,c);
            if(idx[S] != idx[E])
            {
                cout<<lvl[idx[S]][pos[S]-1].first<<endl;
            }
            else
            {
                int NP = to[E];
                int M = tree[idx[S]].get_lca(S,E);
                //cout<<S<<" "<<E<<" "<<M<<endl;
                if(M!=E)
                    cout<<lvl[idx[S]][pos[S]-1].first<<endl;
                else if(NP == 0)
                {
                    cout<<lvl[idx[S]][pos[S]-1].first - lvl[idx[S]][pos[E]-1].first +1<<endl;
                }
                else if(idx[NP] != idx[E])
                {
                    ans = lvl[idx[S]][pos[S]-1].first - lvl[idx[S]][pos[E]-1].first + 1;
                    ans += lvl[idx[NP]][pos[NP]-1].first;
                    cout<<ans<<endl;
                }
                else
                {
                    int NPL = tree[idx[S]].get_lca(NP,E);

                    if(NPL == E)
                        cout<<0<<endl;
                    else
                    {
                        ans = lvl[idx[S]][pos[S]-1].first - lvl[idx[S]][pos[E]-1].first + 1;
                        ans += lvl[idx[NP]][pos[NP]-1].first;
                        cout<<ans<<endl;
                    }
                }
            }

            change_pos(x,y,o[E]);
        }
    }

    return 0;
}
/*

2 3
> V V
< < <
7
1 3 2 2 ^
2 2 1 3 >
2 2 2 2 V
2 2 2 2 <
2 3 1 1 <
2 1 1 1 ^
2 1 1 1 V
*/
