#include<iostream>
#include<string>
#include<cstdio>
///#include<cstring>
#define endl '\n'
using namespace std;
const int maxn=1510;
int n,m;
struct cell
{
    int r,c;
    cell()
    {
        r=c=0;
    }
    cell(int _r,int _c)
    {
        r=_r;
        c=_c;
    }
    void get_new_cell(cell &cur,int dir)
    {
        /**cell k(r,c);
        if(dir==1)k.r--;
        if(dir==2)k.c++;
        if(dir==3)k.r++;
        if(dir==4)k.c--;
        return k;*/
        r=cur.r;
        c=cur.c;
        if(dir==1)
            r--;
        if(dir==2)
            c++;
        if(dir==3)
            r++;
        if(dir==4)
            c--;
    }
    bool is_in_maze()
    {
        return((1<=r&&r<=n)&&(1<=c&&c<=m));
    }
};
int direct[maxn][maxn];
bool used[maxn][maxn];
char s[maxn];
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int direction(char c)
{
    if(c=='^')
        return 1;
    if(c=='>')
        return 2;
    if(c=='v')
        return 3;
    if(c=='<')
        return 4;
}
void translate_s(int row)
{
    for(int i=0; i<m; i++)
        direct[row][i+1]=direction(s[i]);
}
void read()
{
    ///cin>>n>>m;
    scanf("%d%d",&n,&m);
    for(int i=1; i<=n; i++)
    {
        scanf("%s",&s);
        translate_s(i);
    }
    /*for(int i=1;i<=n;i++,cout<<endl)
    {
        for(int j=1;j<=m;j++)
            cout<<direct[i][j]<<' ';
    }*/
}
int solve(cell cur)
{
    used[cur.r][cur.c]=true;
    cell fut;
    fut.get_new_cell(cur,direct[cur.r][cur.c]);
    if(used[fut.r][fut.c])
    {
        used[cur.r][cur.c]=false;
        return 0;
    }
    if(fut.is_in_maze())
    {
        int rez=solve(fut);
        used[cur.r][cur.c]=false;
        if(rez==0)return 0;
        return rez+1;
    }
    used[cur.r][cur.c]=false;
    return 1;

}
void tests()
{
    int q,old_dir,rez;
    cell start,change;
    char dir,buf;
    cin>>q;
    for(int i=0;i<q;i++)
    {
        ///cin>>start.r>>start.c>>change.r>>change.c>>dir;
        scanf("%d%d%d%d%c%c",&start.r,&start.c,&change.r,&change.c,&buf,&dir);
        ///cout<<dir<<endl;
        old_dir=direct[change.r][change.c];
        direct[change.r][change.c]=direction(dir);
        rez=solve(start);
        printf("%d\n",rez);
        ///cout<<rez<<endl;
        ///cout<<endl;
        direct[change.r][change.c]=old_dir;
    }
}
int main()
{
    speed();
    ///<>v^
    read();
    /*int old_dir,rez;
    char dir;
    cell start,change;
    cin>>start.r>>start.c>>change.r>>change.c>>dir;
        cout<<dir<<endl;
        old_dir=direct[change.r][change.c];
        direct[change.r][change.c]=direction(dir);
        rez=solve(start);
        cout<<rez<<endl;
        cout<<endl;*/
    tests();
    return 0;
}
/*
3 4
>>v>
><v>
^>>^
4
2 1 1 1 ^
2 1 2 2 >
2 1 2 1 <
1 1 2 4 ^
*/
///2 1 2 2 >
