#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<int> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

int f(int pos, int lastColor) {
    if (pos == n) {
        return 1;
    }

    if (a[pos] > 0) {
        return f(pos + 1, a[pos]);
    }

    int ways = 0;
    for (int color = 1; color <= k; color++) {
        if (color == lastColor || (pos < n - 1 && color == a[pos + 1])) {
            continue;
        }

        ways += f(pos + 1, color);
        if (ways >= MOD) {
            ways -= MOD;
        }
    }

    return ways;
}

void solve() {
    if (n == 1) {
        if (a[0] == 0) {
            cout << k << endl;
        } else {
            cout << 1 << endl;
        }

        return;
    }

    int ways = 0;
    if (a[0] == 0) {
        for (int color = 1; color <= k; color++) {
            if (color != a[1]) {
                ways += f(1, color);
                if (ways >= MOD) {
                    ways -= MOD;
                }
            }
        }
    } else {
        ways = f(1, a[0]);
    }

    cout << ways << endl;
}

int main() {
    setIO();

    read();

    solve();
}
