#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<int> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

void solve() {
    vector<vector<int>> dp(2, vector<int>(k + 1));

    if (a[0] == 0) {
        for (int j = 1; j <= k; j++) {
            dp[0][j] = 1;
        }
    } else {
        for (int j = 1; j <= k; j++) {
            dp[0][j] = (a[0] == j);
        }
    }

    for (int i = 1; i < n; i++) {
        int sum = 0;
        for (int j = 1; j <= k; j++) {
            sum += dp[i & 1 ^ 1][j];
            if (sum >= MOD) {
                sum -= MOD;
            }
        }

        if (a[i] == 0) {
            for (int j = 1; j <= k; j++) {
                if (i < n - 1 && j == a[i + 1]) {
                    continue;
                }

                dp[i & 1][j] = (sum - dp[i & 1 ^ 1][j] + MOD) % MOD;
            }
        } else {
            for (int j = 1; j <= k; j++) {
                if (j != a[i]) {
                    dp[i & 1][j] = 0;
                } else {
                    dp[i & 1][j] = (sum - dp[i & 1 ^ 1][j] + MOD) % MOD;
                }
            }
        }
    }

    int ways = 0;
    for (int j = 1; j <= k; j++) {
        ways += dp[(n - 1) & 1][j];
        if (ways >= MOD) {
            ways -= MOD;
        }
    }

    cout << ways << endl;
}

int main() {
    setIO();

    read();

    solve();
}
