#include<bits/stdc++.h>
using namespace std;

int n, m;

struct itv //interval
{
    int a, b;
};

bool cmp(const itv& i1, const itv& i2)
{
    return i1.a < i2.a || (i1.a == i2.a && i1.b < i2.b);
}

vector<itv> clients;
vector<int> v, pre;

bool isWholeHeard(const itv& ad, const itv& client)
{
    return client.a <= ad.a && client.b >= ad.b;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n >>m;

    clients.resize(n);

    int i, a, b, maxi = -1, strt, fnl;
    for(i = 0; i < n; i++)
    {
        cin >>a >>b;
        clients[i] = {a, b};
        if(b > maxi)
        {
            maxi = b;
        }
    }

    v.assign(maxi + 1, 0);
    pre.assign(maxi + 1, -1);

    sort(clients.begin(), clients.end(), &cmp);
    /*
    for(auto cl : clients)
    {
        cout <<cl.a <<" " <<cl.b <<"\n";
    }
    */
    itv ii = {1, m + 1};
    for(; ii.a <= maxi; ii.a++, ii.b++)
    {
        int idx = 0;
        for(int idx = 0; clients[idx].a <= ii.b; idx++)
        {
            v[ii.a] += isWholeHeard(ii, clients[idx]);
        }

        if(ii.a == 1)
        {
            pre[1] = v[1];
        }
        else if(v[ii.a] > v[pre[ii.a - 1]])
        {
            pre[ii.a] = ii.a;
        }
        else
        {
            pre[ii.a] = pre[ii.a - 1];
        }

    }

    int ans = -1;
    for(i = m + 1; i < maxi; i++)
    {
        ans = max(ans, v[i] + v[pre[i - m]]);
    }
    cout <<ans <<"\n";
    /*
    for(int a : v)
    {
        cout <<a <<" ";
    }
    cout <<"\n";
    for(int a : pre)
    {
        cout <<a <<" ";
    }
    cout <<"\n";
    */
}
